import * as beam from "../../apache_beam";
export declare type ReadFromKafkaOptions = {
    keyDeserializer?: string;
    valueDeserializer?: string;
    startReadTime?: number;
    maxNumRecords?: number;
    maxReadTime?: number;
    commitOffsetInFinalize?: boolean;
    timestampPolicy?: "ProcessingTime" | "CreateTime" | "LogAppendTime";
};
export declare function readFromKafka<T>(consumerConfig: {
    [key: string]: string;
}, // TODO: Or a map?
topics: string[], options?: ReadFromKafkaOptions): beam.AsyncPTransform<beam.Root, beam.PCollection<T>>;
export declare function readFromKafkaWithMetadata<T>(consumerConfig: {
    [key: string]: string;
}, // TODO: Or a map?
topics: string[], options?: ReadFromKafkaOptions): beam.AsyncPTransform<beam.Root, beam.PCollection<T>>;
export declare type WriteToKafkaOptions = {
    keySerializer?: string;
    valueSerializer?: string;
};
export declare function writeToKafka<K = Uint8Array, V = Uint8Array>(producerConfig: {
    [key: string]: string;
}, // TODO: Or a map?
topics: string[], options?: WriteToKafkaOptions): beam.AsyncPTransform<beam.PCollection<{
    key: K;
    value: V;
}>, {}>;
