import type { RpcTransport } from "@protobuf-ts/runtime-rpc";
import type { ServiceInfo } from "@protobuf-ts/runtime-rpc";
import type { GetProvisionInfoResponse } from "./beam_provision_api";
import type { GetProvisionInfoRequest } from "./beam_provision_api";
import type { UnaryCall } from "@protobuf-ts/runtime-rpc";
import type { RpcOptions } from "@protobuf-ts/runtime-rpc";
/**
 * A service to provide runtime provisioning information to the SDK harness
 * worker instances -- such as pipeline options, resource constraints and
 * other job metadata -- needed by an SDK harness instance to initialize.
 *
 * @generated from protobuf service org.apache.beam.model.fn_execution.v1.ProvisionService
 */
export interface IProvisionServiceClient {
    /**
     * Get provision information for the SDK harness worker instance.
     *
     * @generated from protobuf rpc: GetProvisionInfo(org.apache.beam.model.fn_execution.v1.GetProvisionInfoRequest) returns (org.apache.beam.model.fn_execution.v1.GetProvisionInfoResponse);
     */
    getProvisionInfo(input: GetProvisionInfoRequest, options?: RpcOptions): UnaryCall<GetProvisionInfoRequest, GetProvisionInfoResponse>;
}
/**
 * A service to provide runtime provisioning information to the SDK harness
 * worker instances -- such as pipeline options, resource constraints and
 * other job metadata -- needed by an SDK harness instance to initialize.
 *
 * @generated from protobuf service org.apache.beam.model.fn_execution.v1.ProvisionService
 */
export declare class ProvisionServiceClient implements IProvisionServiceClient, ServiceInfo {
    private readonly _transport;
    typeName: string;
    methods: import("@protobuf-ts/runtime-rpc").MethodInfo<any, any>[];
    options: {
        [extensionName: string]: import("@protobuf-ts/runtime").JsonValue;
    };
    constructor(_transport: RpcTransport);
    /**
     * Get provision information for the SDK harness worker instance.
     *
     * @generated from protobuf rpc: GetProvisionInfo(org.apache.beam.model.fn_execution.v1.GetProvisionInfoRequest) returns (org.apache.beam.model.fn_execution.v1.GetProvisionInfoResponse);
     */
    getProvisionInfo(input: GetProvisionInfoRequest, options?: RpcOptions): UnaryCall<GetProvisionInfoRequest, GetProvisionInfoResponse>;
}
