import { ServiceType } from "@protobuf-ts/runtime-rpc";
import type { BinaryWriteOptions } from "@protobuf-ts/runtime";
import type { IBinaryWriter } from "@protobuf-ts/runtime";
import type { BinaryReadOptions } from "@protobuf-ts/runtime";
import type { IBinaryReader } from "@protobuf-ts/runtime";
import type { PartialMessage } from "@protobuf-ts/runtime";
import { MessageType } from "@protobuf-ts/runtime";
import { MonitoringInfo } from "../../pipeline/v1/metrics";
import { Duration } from "../../../../../../google/protobuf/duration";
import { IsBounded_Enum } from "../../pipeline/v1/beam_runner_api";
import { Timestamp } from "../../../../../../google/protobuf/timestamp";
import { Environment } from "../../pipeline/v1/beam_runner_api";
import { Coder } from "../../pipeline/v1/beam_runner_api";
import { WindowingStrategy } from "../../pipeline/v1/beam_runner_api";
import { PCollection } from "../../pipeline/v1/beam_runner_api";
import { PTransform } from "../../pipeline/v1/beam_runner_api";
import { ApiServiceDescriptor } from "../../pipeline/v1/endpoints";
/**
 * A descriptor for connecting to a remote port using the Beam Fn Data API.
 * Allows for communication between two environments (for example between the
 * runner and the SDK).
 * Stable
 *
 * @generated from protobuf message org.apache.beam.model.fn_execution.v1.RemoteGrpcPort
 */
export interface RemoteGrpcPort {
    /**
     * (Required) An API descriptor which describes where to
     * connect to including any authentication that is required.
     *
     * @generated from protobuf field: org.apache.beam.model.pipeline.v1.ApiServiceDescriptor api_service_descriptor = 1;
     */
    apiServiceDescriptor?: ApiServiceDescriptor;
    /**
     * (Required) The ID of the Coder that will be used to encode and decode data
     * sent over this port.
     *
     * @generated from protobuf field: string coder_id = 2;
     */
    coderId: string;
}
/**
 * Requests the ProcessBundleDescriptor with the given id.
 *
 * @generated from protobuf message org.apache.beam.model.fn_execution.v1.GetProcessBundleDescriptorRequest
 */
export interface GetProcessBundleDescriptorRequest {
    /**
     * @generated from protobuf field: string process_bundle_descriptor_id = 1;
     */
    processBundleDescriptorId: string;
}
/**
 * A request sent by a runner which the SDK is asked to fulfill.
 * For any unsupported request type, an error should be returned with a
 * matching instruction id.
 * Stable
 *
 * @generated from protobuf message org.apache.beam.model.fn_execution.v1.InstructionRequest
 */
export interface InstructionRequest {
    /**
     * (Required) A unique identifier provided by the runner which represents
     * this requests execution. The InstructionResponse MUST have the matching id.
     *
     * @generated from protobuf field: string instruction_id = 1;
     */
    instructionId: string;
    /**
     * @generated from protobuf oneof: request
     */
    request: {
        oneofKind: "processBundle";
        /**
         * @generated from protobuf field: org.apache.beam.model.fn_execution.v1.ProcessBundleRequest process_bundle = 1001;
         */
        processBundle: ProcessBundleRequest;
    } | {
        oneofKind: "processBundleProgress";
        /**
         * @generated from protobuf field: org.apache.beam.model.fn_execution.v1.ProcessBundleProgressRequest process_bundle_progress = 1002;
         */
        processBundleProgress: ProcessBundleProgressRequest;
    } | {
        oneofKind: "processBundleSplit";
        /**
         * @generated from protobuf field: org.apache.beam.model.fn_execution.v1.ProcessBundleSplitRequest process_bundle_split = 1003;
         */
        processBundleSplit: ProcessBundleSplitRequest;
    } | {
        oneofKind: "finalizeBundle";
        /**
         * @generated from protobuf field: org.apache.beam.model.fn_execution.v1.FinalizeBundleRequest finalize_bundle = 1004;
         */
        finalizeBundle: FinalizeBundleRequest;
    } | {
        oneofKind: "monitoringInfos";
        /**
         * @generated from protobuf field: org.apache.beam.model.fn_execution.v1.MonitoringInfosMetadataRequest monitoring_infos = 1005;
         */
        monitoringInfos: MonitoringInfosMetadataRequest;
    } | {
        oneofKind: "harnessMonitoringInfos";
        /**
         * @generated from protobuf field: org.apache.beam.model.fn_execution.v1.HarnessMonitoringInfosRequest harness_monitoring_infos = 1006;
         */
        harnessMonitoringInfos: HarnessMonitoringInfosRequest;
    } | {
        oneofKind: "register";
        /**
         * DEPRECATED
         *
         * @generated from protobuf field: org.apache.beam.model.fn_execution.v1.RegisterRequest register = 1000;
         */
        register: RegisterRequest;
    } | {
        oneofKind: undefined;
    };
}
/**
 * The response for an associated request the SDK had been asked to fulfill.
 * Stable
 *
 * @generated from protobuf message org.apache.beam.model.fn_execution.v1.InstructionResponse
 */
export interface InstructionResponse {
    /**
     * (Required) A reference provided by the runner which represents a requests
     * execution. The InstructionResponse MUST have the matching id when
     * responding to the runner.
     *
     * @generated from protobuf field: string instruction_id = 1;
     */
    instructionId: string;
    /**
     * If this is specified, then this instruction has failed.
     * A human readable string representing the reason as to why processing has
     * failed.
     *
     * @generated from protobuf field: string error = 2;
     */
    error: string;
    /**
     * @generated from protobuf oneof: response
     */
    response: {
        oneofKind: "processBundle";
        /**
         * @generated from protobuf field: org.apache.beam.model.fn_execution.v1.ProcessBundleResponse process_bundle = 1001;
         */
        processBundle: ProcessBundleResponse;
    } | {
        oneofKind: "processBundleProgress";
        /**
         * @generated from protobuf field: org.apache.beam.model.fn_execution.v1.ProcessBundleProgressResponse process_bundle_progress = 1002;
         */
        processBundleProgress: ProcessBundleProgressResponse;
    } | {
        oneofKind: "processBundleSplit";
        /**
         * @generated from protobuf field: org.apache.beam.model.fn_execution.v1.ProcessBundleSplitResponse process_bundle_split = 1003;
         */
        processBundleSplit: ProcessBundleSplitResponse;
    } | {
        oneofKind: "finalizeBundle";
        /**
         * @generated from protobuf field: org.apache.beam.model.fn_execution.v1.FinalizeBundleResponse finalize_bundle = 1004;
         */
        finalizeBundle: FinalizeBundleResponse;
    } | {
        oneofKind: "monitoringInfos";
        /**
         * @generated from protobuf field: org.apache.beam.model.fn_execution.v1.MonitoringInfosMetadataResponse monitoring_infos = 1005;
         */
        monitoringInfos: MonitoringInfosMetadataResponse;
    } | {
        oneofKind: "harnessMonitoringInfos";
        /**
         * @generated from protobuf field: org.apache.beam.model.fn_execution.v1.HarnessMonitoringInfosResponse harness_monitoring_infos = 1006;
         */
        harnessMonitoringInfos: HarnessMonitoringInfosResponse;
    } | {
        oneofKind: "register";
        /**
         * DEPRECATED
         *
         * @generated from protobuf field: org.apache.beam.model.fn_execution.v1.RegisterResponse register = 1000;
         */
        register: RegisterResponse;
    } | {
        oneofKind: undefined;
    };
}
/**
 * A request to provide full MonitoringInfo associated with the entire SDK
 * harness process, not specific to a bundle.
 *
 * An SDK can report metrics using an identifier that only contains the
 * associated payload. A runner who wants to receive the full metrics
 * information can request all the monitoring metadata via a
 * MonitoringInfosMetadataRequest providing a list of ids as necessary.
 *
 * The SDK is allowed to reuse the identifiers
 * for the lifetime of the associated control connection as long
 * as the MonitoringInfo could be reconstructed fully by overwriting its
 * payload field with the bytes specified here.
 *
 * @generated from protobuf message org.apache.beam.model.fn_execution.v1.HarnessMonitoringInfosRequest
 */
export interface HarnessMonitoringInfosRequest {
}
/**
 * @generated from protobuf message org.apache.beam.model.fn_execution.v1.HarnessMonitoringInfosResponse
 */
export interface HarnessMonitoringInfosResponse {
    /**
     * An identifier to MonitoringInfo.payload mapping containing
     * Metrics associated with the SDK harness, not a specific bundle.
     *
     * An SDK can report metrics using an identifier that only contains the
     * associated payload. A runner who wants to receive the full metrics
     * information can request all the monitoring metadata via a
     * MonitoringInfosMetadataRequest providing a list of ids as necessary.
     *
     * The SDK is allowed to reuse the identifiers
     * for the lifetime of the associated control connection as long
     * as the MonitoringInfo could be reconstructed fully by overwriting its
     * payload field with the bytes specified here.
     *
     * @generated from protobuf field: map<string, bytes> monitoring_data = 1;
     */
    monitoringData: {
        [key: string]: Uint8Array;
    };
}
/**
 * A list of objects which can be referred to by the runner in
 * future requests.
 * Stable
 *
 * @generated from protobuf message org.apache.beam.model.fn_execution.v1.RegisterRequest
 */
export interface RegisterRequest {
    /**
     * (Optional) The set of descriptors used to process bundles.
     *
     * @generated from protobuf field: repeated org.apache.beam.model.fn_execution.v1.ProcessBundleDescriptor process_bundle_descriptor = 1;
     */
    processBundleDescriptor: ProcessBundleDescriptor[];
}
/**
 * Stable
 *
 * @generated from protobuf message org.apache.beam.model.fn_execution.v1.RegisterResponse
 */
export interface RegisterResponse {
}
/**
 * Definitions that should be used to construct the bundle processing graph.
 *
 * @generated from protobuf message org.apache.beam.model.fn_execution.v1.ProcessBundleDescriptor
 */
export interface ProcessBundleDescriptor {
    /**
     * (Required) A pipeline level unique id which can be used as a reference to
     * refer to this.
     *
     * @generated from protobuf field: string id = 1;
     */
    id: string;
    /**
     * (Required) A map from pipeline-scoped id to PTransform.
     *
     * @generated from protobuf field: map<string, org.apache.beam.model.pipeline.v1.PTransform> transforms = 2;
     */
    transforms: {
        [key: string]: PTransform;
    };
    /**
     * (Required) A map from pipeline-scoped id to PCollection.
     *
     * @generated from protobuf field: map<string, org.apache.beam.model.pipeline.v1.PCollection> pcollections = 3;
     */
    pcollections: {
        [key: string]: PCollection;
    };
    /**
     * (Required) A map from pipeline-scoped id to WindowingStrategy.
     *
     * @generated from protobuf field: map<string, org.apache.beam.model.pipeline.v1.WindowingStrategy> windowing_strategies = 4;
     */
    windowingStrategies: {
        [key: string]: WindowingStrategy;
    };
    /**
     * (Required) A map from pipeline-scoped id to Coder.
     *
     * @generated from protobuf field: map<string, org.apache.beam.model.pipeline.v1.Coder> coders = 5;
     */
    coders: {
        [key: string]: Coder;
    };
    /**
     * (Required) A map from pipeline-scoped id to Environment.
     *
     * @generated from protobuf field: map<string, org.apache.beam.model.pipeline.v1.Environment> environments = 6;
     */
    environments: {
        [key: string]: Environment;
    };
    /**
     * A descriptor describing the end point to use for State API
     * calls. Required if the Runner intends to send remote references over the
     * data plane or if any of the transforms rely on user state or side inputs.
     *
     * @generated from protobuf field: org.apache.beam.model.pipeline.v1.ApiServiceDescriptor state_api_service_descriptor = 7;
     */
    stateApiServiceDescriptor?: ApiServiceDescriptor;
    /**
     * A descriptor describing the end point to use for Data API for user timers.
     * Required if the ProcessBundleDescriptor contains any transforms that have user timers.
     *
     * @generated from protobuf field: org.apache.beam.model.pipeline.v1.ApiServiceDescriptor timer_api_service_descriptor = 8;
     */
    timerApiServiceDescriptor?: ApiServiceDescriptor;
}
/**
 * One of the applications specifying the scope of work for a bundle.
 * See
 * https://docs.google.com/document/d/1tUDb45sStdR8u7-jBkGdw3OGFK7aa2-V7eo86zYSE_4/edit#heading=h.9g3g5weg2u9
 * for further details.
 *
 * @generated from protobuf message org.apache.beam.model.fn_execution.v1.BundleApplication
 */
export interface BundleApplication {
    /**
     * (Required) The transform to which to pass the element
     *
     * @generated from protobuf field: string transform_id = 1;
     */
    transformId: string;
    /**
     * (Required) Name of the transform's input to which to pass the element.
     *
     * @generated from protobuf field: string input_id = 2;
     */
    inputId: string;
    /**
     * (Required) The encoded element to pass to the transform.
     *
     * @generated from protobuf field: bytes element = 3;
     */
    element: Uint8Array;
    /**
     * The map is keyed by the local output name of the PTransform. Each
     * value represents a lower bound on the timestamps of elements that
     * are produced by this PTransform into each of its output PCollections
     * when invoked with this application.
     *
     * If there is no watermark reported from RestrictionTracker, the runner will
     * use MIN_TIMESTAMP by default.
     *
     * @generated from protobuf field: map<string, google.protobuf.Timestamp> output_watermarks = 4;
     */
    outputWatermarks: {
        [key: string]: Timestamp;
    };
    /**
     * Whether this application potentially produces an unbounded
     * amount of data. Note that this should only be set to BOUNDED if and
     * only if the application is known to produce a finite amount of output.
     *
     * @generated from protobuf field: org.apache.beam.model.pipeline.v1.IsBounded.Enum is_bounded = 5;
     */
    isBounded: IsBounded_Enum;
}
/**
 * An Application should be scheduled for execution after a delay.
 * Either an absolute timestamp or a relative timestamp can represent a
 * scheduled execution time.
 *
 * @generated from protobuf message org.apache.beam.model.fn_execution.v1.DelayedBundleApplication
 */
export interface DelayedBundleApplication {
    /**
     * (Required) The application that should be scheduled.
     *
     * @generated from protobuf field: org.apache.beam.model.fn_execution.v1.BundleApplication application = 1;
     */
    application?: BundleApplication;
    /**
     * Recommended time delay at which the application should be scheduled to
     * execute by the runner. Time delay that equals 0 may be scheduled to execute
     * immediately. The unit of time delay should be microsecond.
     *
     * @generated from protobuf field: google.protobuf.Duration requested_time_delay = 2;
     */
    requestedTimeDelay?: Duration;
}
/**
 * A request to process a given bundle.
 * Stable
 *
 * @generated from protobuf message org.apache.beam.model.fn_execution.v1.ProcessBundleRequest
 */
export interface ProcessBundleRequest {
    /**
     * (Required) A reference to the process bundle descriptor that must be
     * instantiated and executed by the SDK harness.
     *
     * @generated from protobuf field: string process_bundle_descriptor_id = 1;
     */
    processBundleDescriptorId: string;
    /**
     * (Optional) A list of cache tokens that can be used by an SDK to reuse
     * cached data returned by the State API across multiple bundles.
     *
     * Note that SDKs that can efficiently consume this field should declare
     * the beam:protocol:state_caching:v1 capability enabling runners to reduce
     * the amount of memory used.
     *
     * See https://s.apache.org/beam-fn-state-api-and-bundle-processing#heading=h.7ghoih5aig5m
     * for additional details on how to use the cache token with the State API
     * to cache data across bundle boundaries.
     *
     * @generated from protobuf field: repeated org.apache.beam.model.fn_execution.v1.ProcessBundleRequest.CacheToken cache_tokens = 2;
     */
    cacheTokens: ProcessBundleRequest_CacheToken[];
    /**
     * (Optional) Elements to be processed with the bundle. Either all or
     * none of the bundle elements should be included in the ProcessBundleRequest.
     * This embedding is to achieve better efficiency for bundles that contain
     * only small amounts of data and are cheap to be processed on the SDK harness
     * side. This field can be set only if the SDK declares that it supports the
     * beam:protocol:control_request_elements_embedding:v1 capability. See more
     * at https://s.apache.org/beam-fn-api-control-data-embedding.
     *
     * @generated from protobuf field: org.apache.beam.model.fn_execution.v1.Elements elements = 3;
     */
    elements?: Elements;
}
/**
 * Contains the cache token and also defines the scope of what the token applies to.
 *
 * See https://s.apache.org/beam-fn-state-api-and-bundle-processing#heading=h.7ghoih5aig5m
 * for additional details on how to use the cache token with the State API
 * to cache data across bundle boundaries.
 *
 * @generated from protobuf message org.apache.beam.model.fn_execution.v1.ProcessBundleRequest.CacheToken
 */
export interface ProcessBundleRequest_CacheToken {
    /**
     * @generated from protobuf oneof: type
     */
    type: {
        oneofKind: "userState";
        /**
         * @generated from protobuf field: org.apache.beam.model.fn_execution.v1.ProcessBundleRequest.CacheToken.UserState user_state = 1;
         */
        userState: ProcessBundleRequest_CacheToken_UserState;
    } | {
        oneofKind: "sideInput";
        /**
         * @generated from protobuf field: org.apache.beam.model.fn_execution.v1.ProcessBundleRequest.CacheToken.SideInput side_input = 2;
         */
        sideInput: ProcessBundleRequest_CacheToken_SideInput;
    } | {
        oneofKind: undefined;
    };
    /**
     * An opaque token used with the StateKey to create a globally unique
     * identifier.
     *
     * @generated from protobuf field: bytes token = 10;
     */
    token: Uint8Array;
}
/**
 * A flag to indicate a cache token is valid for all user state.
 *
 * @generated from protobuf message org.apache.beam.model.fn_execution.v1.ProcessBundleRequest.CacheToken.UserState
 */
export interface ProcessBundleRequest_CacheToken_UserState {
}
/**
 * A flag to indicate a cache token is valid for a side input.
 *
 * @generated from protobuf message org.apache.beam.model.fn_execution.v1.ProcessBundleRequest.CacheToken.SideInput
 */
export interface ProcessBundleRequest_CacheToken_SideInput {
    /**
     * (Required) The id of the PTransform containing a side input.
     *
     * @generated from protobuf field: string transform_id = 1;
     */
    transformId: string;
    /**
     * (Required) The id of the side input.
     *
     * @generated from protobuf field: string side_input_id = 2;
     */
    sideInputId: string;
}
/**
 * @generated from protobuf message org.apache.beam.model.fn_execution.v1.ProcessBundleResponse
 */
export interface ProcessBundleResponse {
    /**
     * (Optional) Specifies that the bundle has not been completed and the
     * following applications need to be scheduled and executed in the future.
     * A runner that does not yet support residual roots MUST still check that
     * this is empty for correctness.
     *
     * Note that these residual roots must not have been returned as part of a
     * prior split for this bundle.
     *
     * @generated from protobuf field: repeated org.apache.beam.model.fn_execution.v1.DelayedBundleApplication residual_roots = 2;
     */
    residualRoots: DelayedBundleApplication[];
    /**
     * DEPRECATED (Required) The list of metrics or other MonitoredState
     * collected while processing this bundle.
     *
     * @generated from protobuf field: repeated org.apache.beam.model.pipeline.v1.MonitoringInfo monitoring_infos = 3;
     */
    monitoringInfos: MonitoringInfo[];
    /**
     * (Optional) Specifies that the runner must callback to this worker
     * once the output of the bundle is committed. The Runner must send a
     * FinalizeBundleRequest with the instruction id of the ProcessBundleRequest
     * that is related to this ProcessBundleResponse.
     *
     * @generated from protobuf field: bool requires_finalization = 4;
     */
    requiresFinalization: boolean;
    /**
     * An identifier to MonitoringInfo.payload mapping.
     *
     * An SDK can report metrics using an identifier that only contains the
     * associated payload. A runner who wants to receive the full metrics
     * information can request all the monitoring metadata via a
     * MonitoringInfosMetadataRequest providing a list of ids as necessary.
     *
     * The SDK is allowed to reuse the identifiers across multiple bundles as long
     * as the MonitoringInfo could be reconstructed fully by overwriting its
     * payload field with the bytes specified here.
     *
     * @generated from protobuf field: map<string, bytes> monitoring_data = 5;
     */
    monitoringData: {
        [key: string]: Uint8Array;
    };
    /**
     * (Optional) Output elements of the processed bundle. Either all or
     * none of the bundle elements should be included in the ProcessBundleResponse.
     * This embedding is to achieve better efficiency for bundles that only
     * contain small amounts of data. his field can be set only if the runner
     * declares that it supports the
     * beam:protocol:control_request_elements_embedding:v1 capability. See more at
     * https://s.apache.org/beam-fn-api-control-data-embedding.
     *
     * @generated from protobuf field: org.apache.beam.model.fn_execution.v1.Elements elements = 6;
     */
    elements?: Elements;
}
/**
 * A request to report progress information for a given bundle.
 * This is an optional request to be handled and is used to support advanced
 * SDK features such as SplittableDoFn, user level metrics etc.
 *
 * @generated from protobuf message org.apache.beam.model.fn_execution.v1.ProcessBundleProgressRequest
 */
export interface ProcessBundleProgressRequest {
    /**
     * (Required) A reference to an active process bundle request with the given
     * instruction id.
     *
     * @generated from protobuf field: string instruction_id = 1;
     */
    instructionId: string;
}
/**
 * A request to provide full MonitoringInfo for a set of provided ids.
 *
 * An SDK can report metrics using an identifier that only contains the
 * associated payload. A runner who wants to receive the full metrics
 * information can request all the monitoring metadata via a
 * MonitoringInfosMetadataRequest providing a list of ids as necessary.
 *
 * The SDK is allowed to reuse the identifiers for the lifetime of the
 * associated control connection as long as the MonitoringInfo could be
 * reconstructed fully by overwriting its payload field with the bytes specified
 * here.
 *
 * @generated from protobuf message org.apache.beam.model.fn_execution.v1.MonitoringInfosMetadataRequest
 */
export interface MonitoringInfosMetadataRequest {
    /**
     * A list of ids for which the full MonitoringInfo is requested for.
     *
     * @generated from protobuf field: repeated string monitoring_info_id = 1;
     */
    monitoringInfoId: string[];
}
/**
 * @generated from protobuf message org.apache.beam.model.fn_execution.v1.ProcessBundleProgressResponse
 */
export interface ProcessBundleProgressResponse {
    /**
     * DEPRECATED (Required) The list of metrics or other MonitoredState
     * collected while processing this bundle.
     *
     * @generated from protobuf field: repeated org.apache.beam.model.pipeline.v1.MonitoringInfo monitoring_infos = 3;
     */
    monitoringInfos: MonitoringInfo[];
    /**
     * An identifier to MonitoringInfo.payload mapping.
     *
     * An SDK can report metrics using an identifier that only contains the
     * associated payload. A runner who wants to receive the full metrics
     * information can request all the monitoring metadata via a
     * MonitoringInfosMetadataRequest providing a list of ids as necessary.
     *
     * The SDK is allowed to reuse the identifiers
     * for the lifetime of the associated control connection as long
     * as the MonitoringInfo could be reconstructed fully by overwriting its
     * payload field with the bytes specified here.
     *
     * @generated from protobuf field: map<string, bytes> monitoring_data = 5;
     */
    monitoringData: {
        [key: string]: Uint8Array;
    };
}
/**
 * A response that contains the full mapping information associated with
 * a specified set of identifiers.
 *
 * An SDK can report metrics using an identifier that only contains the
 * associated payload. A runner who wants to receive the full metrics
 * information can request all the monitoring metadata via a
 * MonitoringInfosMetadataRequest providing a list of ids as necessary.
 *
 * The SDK is allowed to reuse the identifiers
 * for the lifetime of the associated control connection as long
 * as the MonitoringInfo could be reconstructed fully by overwriting its
 * payload field with the bytes specified here.
 *
 * @generated from protobuf message org.apache.beam.model.fn_execution.v1.MonitoringInfosMetadataResponse
 */
export interface MonitoringInfosMetadataResponse {
    /**
     * A mapping from an identifier to the full metrics information.
     *
     * @generated from protobuf field: map<string, org.apache.beam.model.pipeline.v1.MonitoringInfo> monitoring_info = 1;
     */
    monitoringInfo: {
        [key: string]: MonitoringInfo;
    };
}
/**
 * Represents a request to the SDK to split a currently active bundle.
 *
 * @generated from protobuf message org.apache.beam.model.fn_execution.v1.ProcessBundleSplitRequest
 */
export interface ProcessBundleSplitRequest {
    /**
     * (Required) A reference to an active process bundle request with the given
     * instruction id.
     *
     * @generated from protobuf field: string instruction_id = 1;
     */
    instructionId: string;
    /**
     * (Required) Specifies the desired split for each transform.
     *
     * Currently only splits at gRPC read operations are supported.
     * This may, of course, limit the amount of work downstream operations
     * receive.
     *
     * @generated from protobuf field: map<string, org.apache.beam.model.fn_execution.v1.ProcessBundleSplitRequest.DesiredSplit> desired_splits = 3;
     */
    desiredSplits: {
        [key: string]: ProcessBundleSplitRequest_DesiredSplit;
    };
}
/**
 * A message specifying the desired split for a single transform.
 *
 * @generated from protobuf message org.apache.beam.model.fn_execution.v1.ProcessBundleSplitRequest.DesiredSplit
 */
export interface ProcessBundleSplitRequest_DesiredSplit {
    /**
     * (Required) The fraction of known work remaining in this bundle
     * for this transform that should be kept by the SDK after this split.
     *
     * Set to 0 to "checkpoint" as soon as possible (keeping as little work as
     * possible and returning the remainder).
     *
     * @generated from protobuf field: double fraction_of_remainder = 1;
     */
    fractionOfRemainder: number;
    /**
     * (Optional) A set of allowed element indices where the SDK may split. When
     * this is empty, there are no constraints on where to split.
     *
     * @generated from protobuf field: repeated int64 allowed_split_points = 3;
     */
    allowedSplitPoints: bigint[];
    /**
     * (Required for gRPC Read operation transforms) Number of total elements
     * expected to be sent to this GrpcRead operation, required to correctly
     * account for unreceived data when determining where to split.
     *
     * @generated from protobuf field: int64 estimated_input_elements = 2;
     */
    estimatedInputElements: bigint;
}
/**
 * Represents a partition of the bundle: a "primary" and a "residual", with the
 * following properties:
 * - The work in primary and residual doesn't overlap, and combined, adds up
 *   to the work in the current bundle if the split hadn't happened.
 * - The current bundle, if it keeps executing, will have done exactly none of
 *   the work under residual_roots and none of the elements at and beyond the
 *   first_residual_element.
 * - The current bundle, if no further splits happen, will have done exactly
 *   the work under primary_roots and all elements up to and including the
 *   channel splits last_primary_element.
 *
 * This allows the SDK to relinquish ownership of and commit to not process some
 * of the elements that it may have been sent (the residual) while retaining
 * ownership and commitment to finish the other portion (the primary).
 *
 * For example, lets say the SDK is processing elements A B C D E and a split
 * request comes in. The SDK could return a response with a channel split
 * representing a last_primary_element of 3 (D) and first_residual_element of 4
 * (E). The SDK is now responsible for processing A B C D and the runner must
 * process E in the future. A future split request could have the SDK split the
 * elements B into B1 and B2 and C into C1 and C2 representing their primary and
 * residual roots. The SDK would return a response with a channel split
 * representing a last_primary_element of 0 (A) and first_residual_element of 3
 * (D) with primary_roots (B1, C1) and residual_roots (B2, C2). The SDK is now
 * responsible for processing A B1 C1 and the runner must process C2 D2 (and E
 * from the prior split) in the future. Yet another future split request could
 * have the SDK could split B1 further into B1a and B1b primary and residuals
 * and return C2 as a residual (assuming C2 was left unprocessed). The SDK would
 * return a response with a channel split representing a last_primary_element of
 * 0 (A) and first_residual_element of 4 (E) with primary_roots (B1a) and
 * residual_roots (B1b, C1). The SDK is now responsible for processing A B1a the
 * runner must process B1b C1 (in addition to C2, D, E from prior splits) in the
 * future.
 *
 * For more rigorous definitions see https://s.apache.org/beam-breaking-fusion
 *
 * @generated from protobuf message org.apache.beam.model.fn_execution.v1.ProcessBundleSplitResponse
 */
export interface ProcessBundleSplitResponse {
    /**
     * (Optional) Root applications that should replace the current bundle.
     *
     * Note that primary roots can only be specified if a channel split's
     * last_primary_element + 1 < first_residual_element
     *
     * Note that there must be a corresponding residual root contained within
     * residual_roots representing the remainder of processing for the original
     * element this this primary root represents a fraction of.
     *
     * @generated from protobuf field: repeated org.apache.beam.model.fn_execution.v1.BundleApplication primary_roots = 1;
     */
    primaryRoots: BundleApplication[];
    /**
     * (Optional) Root applications that have been removed from the current bundle and
     * have to be executed in a separate bundle (e.g. in parallel on a different
     * worker, or after the current bundle completes, etc.)
     *
     * Note that residual roots can only be specified if a channel split's
     * last_primary_element + 1 < first_residual_element
     *
     * Note that there must be a corresponding primary root contained within
     * primary_roots representing the remainder of processing for the original
     * element this this residual root represents a fraction of.
     *
     * Note that subsequent splits must not return prior residual roots.
     *
     * @generated from protobuf field: repeated org.apache.beam.model.fn_execution.v1.DelayedBundleApplication residual_roots = 2;
     */
    residualRoots: DelayedBundleApplication[];
    /**
     * (Required) Partitions of input data channels into primary and residual
     * elements, if any. Must not include any elements represented in the bundle
     * applications roots above of the current split or any prior split of the
     * same bundle.
     *
     * @generated from protobuf field: repeated org.apache.beam.model.fn_execution.v1.ProcessBundleSplitResponse.ChannelSplit channel_splits = 3;
     */
    channelSplits: ProcessBundleSplitResponse_ChannelSplit[];
}
/**
 * Represents contiguous portions of the data channel that are either
 * entirely processed or entirely unprocessed and belong to the primary
 * or residual respectively.
 *
 * This affords both a more efficient representation over the FnAPI
 * (if the bundle is large) and often a more efficient representation
 * on the runner side (e.g. if the set of elements can be represented
 * as some range in an underlying dataset).
 *
 * Note that for a split the following properties must hold:
 * - last_primary_element < first_residual_element
 * - primary roots and residual roots can only be specified if the
 *   last_primary_element + 1 < first_residual_element
 *   (typically there is one primary and residual root per element in the
 *   range (last_primary_element, first_residual_element))
 * - primary roots and residual roots must represent a disjoint but full
 *   coverage of work represented by the elements between last_primary_element
 *   and first_residual_element
 *
 * Note that subsequent splits of the same bundle must ensure that:
 * - the first_residual_element does not increase
 * - the first_residual_element does not decrease if there were residual
 *   or primary roots returned in a prior split.
 *
 * @generated from protobuf message org.apache.beam.model.fn_execution.v1.ProcessBundleSplitResponse.ChannelSplit
 */
export interface ProcessBundleSplitResponse_ChannelSplit {
    /**
     * (Required) The grpc read transform reading this channel.
     *
     * @generated from protobuf field: string transform_id = 1;
     */
    transformId: string;
    /**
     * (Required) The last element of the input channel that should be entirely
     * considered part of the primary, identified by its absolute zero-based
     * index in the (ordered) channel.
     *
     * @generated from protobuf field: int64 last_primary_element = 2;
     */
    lastPrimaryElement: bigint;
    /**
     * (Required) The first element of the input channel that should be entirely
     * considered part of the residual, identified by its absolute zero-based
     * index in the (ordered) channel.
     *
     * @generated from protobuf field: int64 first_residual_element = 3;
     */
    firstResidualElement: bigint;
}
/**
 * @generated from protobuf message org.apache.beam.model.fn_execution.v1.FinalizeBundleRequest
 */
export interface FinalizeBundleRequest {
    /**
     * (Required) A reference to a completed process bundle request with the given
     * instruction id.
     *
     * @generated from protobuf field: string instruction_id = 1;
     */
    instructionId: string;
}
/**
 * Empty
 *
 * @generated from protobuf message org.apache.beam.model.fn_execution.v1.FinalizeBundleResponse
 */
export interface FinalizeBundleResponse {
}
/**
 * Messages used to represent logical byte streams.
 * Stable
 *
 * @generated from protobuf message org.apache.beam.model.fn_execution.v1.Elements
 */
export interface Elements {
    /**
     * (Optional) A list containing parts of logical byte streams.
     *
     * @generated from protobuf field: repeated org.apache.beam.model.fn_execution.v1.Elements.Data data = 1;
     */
    data: Elements_Data[];
    /**
     * (Optional)  A list of timer byte streams.
     *
     * @generated from protobuf field: repeated org.apache.beam.model.fn_execution.v1.Elements.Timers timers = 2;
     */
    timers: Elements_Timers[];
}
/**
 * Represents multiple encoded elements in nested context for a given named
 * instruction and transform.
 *
 * @generated from protobuf message org.apache.beam.model.fn_execution.v1.Elements.Data
 */
export interface Elements_Data {
    /**
     * (Required) A reference to an active instruction request with the given
     * instruction id.
     *
     * @generated from protobuf field: string instruction_id = 1;
     */
    instructionId: string;
    /**
     * (Required) A definition representing a consumer or producer of this data.
     * If received by a harness, this represents the consumer within that
     * harness that should consume these bytes. If sent by a harness, this
     * represents the producer of these bytes.
     *
     * Note that a single element may span multiple Data messages.
     *
     * Note that a sending/receiving pair should share the same identifier.
     *
     * @generated from protobuf field: string transform_id = 2;
     */
    transformId: string;
    /**
     * (Optional) Represents a part of a logical byte stream. Elements within
     * the logical byte stream are encoded in the nested context and
     * concatenated together.
     *
     * @generated from protobuf field: bytes data = 3;
     */
    data: Uint8Array;
    /**
     * (Optional) Set this bit to indicate the this is the last data block
     * for the given instruction and transform, ending the stream.
     *
     * @generated from protobuf field: bool is_last = 4;
     */
    isLast: boolean;
}
/**
 * Represent the encoded user timer for a given instruction, transform and
 * timer id.
 *
 * @generated from protobuf message org.apache.beam.model.fn_execution.v1.Elements.Timers
 */
export interface Elements_Timers {
    /**
     * (Required) A reference to an active instruction request with the given
     * instruction id.
     *
     * @generated from protobuf field: string instruction_id = 1;
     */
    instructionId: string;
    /**
     * (Required) A definition representing a consumer or producer of this data.
     * If received by a harness, this represents the consumer within that
     * harness that should consume these timers. If sent by a harness, this
     * represents the producer of these timers.
     *
     * @generated from protobuf field: string transform_id = 2;
     */
    transformId: string;
    /**
     * (Required) The local timer family name used to identify the associated
     * timer family specification
     *
     * @generated from protobuf field: string timer_family_id = 3;
     */
    timerFamilyId: string;
    /**
     * (Optional) Represents a logical byte stream of timers. Encoded according
     * to the coder in the timer spec.
     *
     * @generated from protobuf field: bytes timers = 4;
     */
    timers: Uint8Array;
    /**
     * (Optional) Set this bit to indicate the this is the last data block
     * for the given instruction and transform, ending the stream.
     *
     * @generated from protobuf field: bool is_last = 5;
     */
    isLast: boolean;
}
/**
 * @generated from protobuf message org.apache.beam.model.fn_execution.v1.StateRequest
 */
export interface StateRequest {
    /**
     * (Required) A unique identifier provided by the SDK which represents this
     * requests execution. The StateResponse corresponding with this request
     * will have the matching id.
     *
     * @generated from protobuf field: string id = 1;
     */
    id: string;
    /**
     * (Required) The associated instruction id of the work that is currently
     * being processed. This allows for the runner to associate any modifications
     * to state to be committed with the appropriate work execution.
     *
     * @generated from protobuf field: string instruction_id = 2;
     */
    instructionId: string;
    /**
     * (Required) The state key this request is for.
     *
     * @generated from protobuf field: org.apache.beam.model.fn_execution.v1.StateKey state_key = 3;
     */
    stateKey?: StateKey;
    /**
     * @generated from protobuf oneof: request
     */
    request: {
        oneofKind: "get";
        /**
         * A request to get state.
         *
         * @generated from protobuf field: org.apache.beam.model.fn_execution.v1.StateGetRequest get = 1000;
         */
        get: StateGetRequest;
    } | {
        oneofKind: "append";
        /**
         * A request to append to state.
         *
         * @generated from protobuf field: org.apache.beam.model.fn_execution.v1.StateAppendRequest append = 1001;
         */
        append: StateAppendRequest;
    } | {
        oneofKind: "clear";
        /**
         * A request to clear state.
         *
         * @generated from protobuf field: org.apache.beam.model.fn_execution.v1.StateClearRequest clear = 1002;
         */
        clear: StateClearRequest;
    } | {
        oneofKind: undefined;
    };
}
/**
 * @generated from protobuf message org.apache.beam.model.fn_execution.v1.StateResponse
 */
export interface StateResponse {
    /**
     * (Required) A reference provided by the SDK which represents a requests
     * execution. The StateResponse must have the matching id when responding
     * to the SDK.
     *
     * @generated from protobuf field: string id = 1;
     */
    id: string;
    /**
     * (Optional) If this is specified, then the state request has failed.
     * A human readable string representing the reason as to why the request
     * failed.
     *
     * @generated from protobuf field: string error = 2;
     */
    error: string;
    /**
     * @generated from protobuf oneof: response
     */
    response: {
        oneofKind: "get";
        /**
         * A response to getting state.
         *
         * @generated from protobuf field: org.apache.beam.model.fn_execution.v1.StateGetResponse get = 1000;
         */
        get: StateGetResponse;
    } | {
        oneofKind: "append";
        /**
         * A response to appending to state.
         *
         * @generated from protobuf field: org.apache.beam.model.fn_execution.v1.StateAppendResponse append = 1001;
         */
        append: StateAppendResponse;
    } | {
        oneofKind: "clear";
        /**
         * A response to clearing state.
         *
         * @generated from protobuf field: org.apache.beam.model.fn_execution.v1.StateClearResponse clear = 1002;
         */
        clear: StateClearResponse;
    } | {
        oneofKind: undefined;
    };
}
/**
 * @generated from protobuf message org.apache.beam.model.fn_execution.v1.StateKey
 */
export interface StateKey {
    /**
     * @generated from protobuf oneof: type
     */
    type: {
        oneofKind: "runner";
        /**
         * @generated from protobuf field: org.apache.beam.model.fn_execution.v1.StateKey.Runner runner = 1;
         */
        runner: StateKey_Runner;
    } | {
        oneofKind: "multimapSideInput";
        /**
         * @generated from protobuf field: org.apache.beam.model.fn_execution.v1.StateKey.MultimapSideInput multimap_side_input = 2;
         */
        multimapSideInput: StateKey_MultimapSideInput;
    } | {
        oneofKind: "bagUserState";
        /**
         * @generated from protobuf field: org.apache.beam.model.fn_execution.v1.StateKey.BagUserState bag_user_state = 3;
         */
        bagUserState: StateKey_BagUserState;
    } | {
        oneofKind: "iterableSideInput";
        /**
         * @generated from protobuf field: org.apache.beam.model.fn_execution.v1.StateKey.IterableSideInput iterable_side_input = 4;
         */
        iterableSideInput: StateKey_IterableSideInput;
    } | {
        oneofKind: "multimapKeysSideInput";
        /**
         * @generated from protobuf field: org.apache.beam.model.fn_execution.v1.StateKey.MultimapKeysSideInput multimap_keys_side_input = 5;
         */
        multimapKeysSideInput: StateKey_MultimapKeysSideInput;
    } | {
        oneofKind: "multimapKeysUserState";
        /**
         * @generated from protobuf field: org.apache.beam.model.fn_execution.v1.StateKey.MultimapKeysUserState multimap_keys_user_state = 6;
         */
        multimapKeysUserState: StateKey_MultimapKeysUserState;
    } | {
        oneofKind: "multimapUserState";
        /**
         * @generated from protobuf field: org.apache.beam.model.fn_execution.v1.StateKey.MultimapUserState multimap_user_state = 7;
         */
        multimapUserState: StateKey_MultimapUserState;
    } | {
        oneofKind: undefined;
    };
}
/**
 * @generated from protobuf message org.apache.beam.model.fn_execution.v1.StateKey.Runner
 */
export interface StateKey_Runner {
    /**
     * (Required) Opaque information supplied by the runner. Used to support
     * remote references.
     * https://s.apache.org/beam-fn-api-send-and-receive-data
     *
     * Used by state backed iterable. And in this use case, request type can
     * only be of type get. Details see:
     * https://s.apache.org/beam-fn-api-state-backed-iterables
     *
     * @generated from protobuf field: bytes key = 1;
     */
    key: Uint8Array;
}
/**
 * Represents a request for the values associated with a specified window
 * in a PCollection. See
 * https://s.apache.org/beam-fn-state-api-and-bundle-processing for further
 * details.
 *
 * Can only be used to perform StateGetRequests on side inputs of the URN
 * beam:side_input:iterable:v1.
 *
 * For a PCollection<V>, the response data stream will be a concatenation
 * of all V's. See https://s.apache.org/beam-fn-api-send-and-receive-data
 * for further details.
 *
 * @generated from protobuf message org.apache.beam.model.fn_execution.v1.StateKey.IterableSideInput
 */
export interface StateKey_IterableSideInput {
    /**
     * (Required) The id of the PTransform containing a side input.
     *
     * @generated from protobuf field: string transform_id = 1;
     */
    transformId: string;
    /**
     * (Required) The id of the side input.
     *
     * @generated from protobuf field: string side_input_id = 2;
     */
    sideInputId: string;
    /**
     * (Required) The window (after mapping the currently executing elements
     * window into the side input windows domain) encoded in a nested context.
     *
     * @generated from protobuf field: bytes window = 3;
     */
    window: Uint8Array;
}
/**
 * Represents a request for the values associated with a specified user key
 * and window in a PCollection. See
 * https://s.apache.org/beam-fn-state-api-and-bundle-processing for further
 * details.
 *
 * Can only be used to perform StateGetRequests on side inputs of the URN
 * beam:side_input:multimap:v1.
 *
 * For a PCollection<KV<K, V>>, the response data stream will be a
 * concatenation of all V's associated with the specified key K. See
 * https://s.apache.org/beam-fn-api-send-and-receive-data for further
 * details.
 *
 * @generated from protobuf message org.apache.beam.model.fn_execution.v1.StateKey.MultimapSideInput
 */
export interface StateKey_MultimapSideInput {
    /**
     * (Required) The id of the PTransform containing a side input.
     *
     * @generated from protobuf field: string transform_id = 1;
     */
    transformId: string;
    /**
     * (Required) The id of the side input.
     *
     * @generated from protobuf field: string side_input_id = 2;
     */
    sideInputId: string;
    /**
     * (Required) The window (after mapping the currently executing elements
     * window into the side input windows domain) encoded in a nested context.
     *
     * @generated from protobuf field: bytes window = 3;
     */
    window: Uint8Array;
    /**
     * (Required) The key encoded in a nested context.
     *
     * @generated from protobuf field: bytes key = 4;
     */
    key: Uint8Array;
}
/**
 * Represents a request for the keys associated with a specified window in a PCollection. See
 * https://s.apache.org/beam-fn-state-api-and-bundle-processing for further
 * details.
 *
 * Can only be used to perform StateGetRequests on side inputs of the URN
 * beam:side_input:multimap:v1.
 *
 * For a PCollection<KV<K, V>>, the response data stream will be a
 * concatenation of all K's associated with the specified window. See
 * https://s.apache.org/beam-fn-api-send-and-receive-data for further
 * details.
 *
 * @generated from protobuf message org.apache.beam.model.fn_execution.v1.StateKey.MultimapKeysSideInput
 */
export interface StateKey_MultimapKeysSideInput {
    /**
     * (Required) The id of the PTransform containing a side input.
     *
     * @generated from protobuf field: string transform_id = 1;
     */
    transformId: string;
    /**
     * (Required) The id of the side input.
     *
     * @generated from protobuf field: string side_input_id = 2;
     */
    sideInputId: string;
    /**
     * (Required) The window (after mapping the currently executing elements
     * window into the side input windows domain) encoded in a nested context.
     *
     * @generated from protobuf field: bytes window = 3;
     */
    window: Uint8Array;
}
/**
 * Represents a request for an unordered set of values associated with a
 * specified user key and window for a PTransform. See
 * https://s.apache.org/beam-fn-state-api-and-bundle-processing for further
 * details.
 *
 * The response data stream will be a concatenation of all V's associated
 * with the specified user key and window.
 * See https://s.apache.org/beam-fn-api-send-and-receive-data for further
 * details.
 *
 * @generated from protobuf message org.apache.beam.model.fn_execution.v1.StateKey.BagUserState
 */
export interface StateKey_BagUserState {
    /**
     * (Required) The id of the PTransform containing user state.
     *
     * @generated from protobuf field: string transform_id = 1;
     */
    transformId: string;
    /**
     * (Required) The id of the user state.
     *
     * @generated from protobuf field: string user_state_id = 2;
     */
    userStateId: string;
    /**
     * (Required) The window encoded in a nested context.
     *
     * @generated from protobuf field: bytes window = 3;
     */
    window: Uint8Array;
    /**
     * (Required) The key of the currently executing element encoded in a
     * nested context.
     *
     * @generated from protobuf field: bytes key = 4;
     */
    key: Uint8Array;
}
/**
 * Represents a request for the keys of a multimap associated with a specified
 * user key and window for a PTransform. See
 * https://s.apache.org/beam-fn-state-api-and-bundle-processing for further
 * details.
 *
 * Can only be used to perform StateGetRequests and StateClearRequests on the
 * user state.
 *
 * The response data stream will be a concatenation of all K's associated
 * with the specified user key and window.
 * See https://s.apache.org/beam-fn-api-send-and-receive-data for further
 * details.
 *
 * @generated from protobuf message org.apache.beam.model.fn_execution.v1.StateKey.MultimapKeysUserState
 */
export interface StateKey_MultimapKeysUserState {
    /**
     * (Required) The id of the PTransform containing user state.
     *
     * @generated from protobuf field: string transform_id = 1;
     */
    transformId: string;
    /**
     * (Required) The id of the user state.
     *
     * @generated from protobuf field: string user_state_id = 2;
     */
    userStateId: string;
    /**
     * (Required) The window encoded in a nested context.
     *
     * @generated from protobuf field: bytes window = 3;
     */
    window: Uint8Array;
    /**
     * (Required) The key of the currently executing element encoded in a
     * nested context.
     *
     * @generated from protobuf field: bytes key = 4;
     */
    key: Uint8Array;
}
/**
 * Represents a request for the values of the map key associated with a
 * specified user key and window for a PTransform. See
 * https://s.apache.org/beam-fn-state-api-and-bundle-processing for further
 * details.
 *
 * The response data stream will be a concatenation of all V's associated
 * with the specified map key, user key, and window.
 * See https://s.apache.org/beam-fn-api-send-and-receive-data for further
 * details.
 *
 * @generated from protobuf message org.apache.beam.model.fn_execution.v1.StateKey.MultimapUserState
 */
export interface StateKey_MultimapUserState {
    /**
     * (Required) The id of the PTransform containing user state.
     *
     * @generated from protobuf field: string transform_id = 1;
     */
    transformId: string;
    /**
     * (Required) The id of the user state.
     *
     * @generated from protobuf field: string user_state_id = 2;
     */
    userStateId: string;
    /**
     * (Required) The window encoded in a nested context.
     *
     * @generated from protobuf field: bytes window = 3;
     */
    window: Uint8Array;
    /**
     * (Required) The key of the currently executing element encoded in a
     * nested context.
     *
     * @generated from protobuf field: bytes key = 4;
     */
    key: Uint8Array;
    /**
     * (Required) The map key encoded in a nested context.
     *
     * @generated from protobuf field: bytes map_key = 5;
     */
    mapKey: Uint8Array;
}
/**
 * A request to get state.
 *
 * @generated from protobuf message org.apache.beam.model.fn_execution.v1.StateGetRequest
 */
export interface StateGetRequest {
    /**
     * (Optional) If specified, signals to the runner that the response
     * should resume from the following continuation token.
     *
     * If unspecified, signals to the runner that the response should start
     * from the beginning of the logical continuable stream.
     *
     * @generated from protobuf field: bytes continuation_token = 1;
     */
    continuationToken: Uint8Array;
}
/**
 * A response to get state representing a logical byte stream which can be
 * continued using the state API.
 *
 * @generated from protobuf message org.apache.beam.model.fn_execution.v1.StateGetResponse
 */
export interface StateGetResponse {
    /**
     * (Optional) If specified, represents a token which can be used with the
     * state API to get the next chunk of this logical byte stream. The end of
     * the logical byte stream is signalled by this field being unset.
     *
     * @generated from protobuf field: bytes continuation_token = 1;
     */
    continuationToken: Uint8Array;
    /**
     * Represents a part of a logical byte stream. Elements within
     * the logical byte stream are encoded in the nested context and
     * concatenated together.
     *
     * @generated from protobuf field: bytes data = 2;
     */
    data: Uint8Array;
}
/**
 * A request to append state.
 *
 * @generated from protobuf message org.apache.beam.model.fn_execution.v1.StateAppendRequest
 */
export interface StateAppendRequest {
    /**
     * Represents a part of a logical byte stream. Elements within
     * the logical byte stream are encoded in the nested context and
     * multiple append requests are concatenated together.
     *
     * @generated from protobuf field: bytes data = 1;
     */
    data: Uint8Array;
}
/**
 * A response to append state.
 *
 * @generated from protobuf message org.apache.beam.model.fn_execution.v1.StateAppendResponse
 */
export interface StateAppendResponse {
}
/**
 * A request to clear state.
 *
 * @generated from protobuf message org.apache.beam.model.fn_execution.v1.StateClearRequest
 */
export interface StateClearRequest {
}
/**
 * A response to clear state.
 *
 * @generated from protobuf message org.apache.beam.model.fn_execution.v1.StateClearResponse
 */
export interface StateClearResponse {
}
/**
 * A log entry
 *
 * @generated from protobuf message org.apache.beam.model.fn_execution.v1.LogEntry
 */
export interface LogEntry {
    /**
     * (Required) The severity of the log statement.
     *
     * @generated from protobuf field: org.apache.beam.model.fn_execution.v1.LogEntry.Severity.Enum severity = 1;
     */
    severity: LogEntry_Severity_Enum;
    /**
     * (Required) The time at which this log statement occurred.
     *
     * @generated from protobuf field: google.protobuf.Timestamp timestamp = 2;
     */
    timestamp?: Timestamp;
    /**
     * (Required) A human readable message.
     *
     * @generated from protobuf field: string message = 3;
     */
    message: string;
    /**
     * (Optional) An optional trace of the functions involved. For example, in
     * Java this can include multiple causes and multiple suppressed exceptions.
     *
     * @generated from protobuf field: string trace = 4;
     */
    trace: string;
    /**
     * (Optional) A reference to the instruction this log statement is associated
     * with.
     *
     * @generated from protobuf field: string instruction_id = 5;
     */
    instructionId: string;
    /**
     * (Optional) A reference to the transform this log statement is
     * associated with.
     *
     * @generated from protobuf field: string transform_id = 6;
     */
    transformId: string;
    /**
     * (Optional) Human-readable name of the function or method being invoked,
     * with optional context such as the class or package name. The format can
     * vary by language. For example:
     *   qual.if.ied.Class.method (Java)
     *   dir/package.func (Go)
     *   module.function (Python)
     *   file.cc:382 (C++)
     *
     * @generated from protobuf field: string log_location = 7;
     */
    logLocation: string;
    /**
     * (Optional) The name of the thread this log statement is associated with.
     *
     * @generated from protobuf field: string thread = 8;
     */
    thread: string;
}
/**
 * A list of log entries, enables buffering and batching of multiple
 * log messages using the logging API.
 *
 * @generated from protobuf message org.apache.beam.model.fn_execution.v1.LogEntry.List
 */
export interface LogEntry_List {
    /**
     * (Required) One or or more log messages.
     *
     * @generated from protobuf field: repeated org.apache.beam.model.fn_execution.v1.LogEntry log_entries = 1;
     */
    logEntries: LogEntry[];
}
/**
 * The severity of the event described in a log entry, expressed as one of the
 * severity levels listed below. For your reference, the levels are
 * assigned the listed numeric values. The effect of using numeric values
 * other than those listed is undefined.
 *
 * If you are writing log entries, you should map other severity encodings to
 * one of these standard levels. For example, you might map all of
 * Java's FINE, FINER, and FINEST levels to `Severity.DEBUG`.
 *
 * This list is intentionally not comprehensive; the intent is to provide a
 * common set of "good enough" severity levels so that logging front ends
 * can provide filtering and searching across log types. Users of the API are
 * free not to use all severity levels in their log messages.
 *
 * @generated from protobuf message org.apache.beam.model.fn_execution.v1.LogEntry.Severity
 */
export interface LogEntry_Severity {
}
/**
 * @generated from protobuf enum org.apache.beam.model.fn_execution.v1.LogEntry.Severity.Enum
 */
export declare enum LogEntry_Severity_Enum {
    /**
     * Unspecified level information. Will be logged at the TRACE level.
     *
     * @generated from protobuf enum value: UNSPECIFIED = 0;
     */
    UNSPECIFIED = 0,
    /**
     * @generated from protobuf enum value: TRACE = 1;
     */
    TRACE = 1,
    /**
     * Debugging information.
     *
     * @generated from protobuf enum value: DEBUG = 2;
     */
    DEBUG = 2,
    /**
     * Normal events.
     *
     * @generated from protobuf enum value: INFO = 3;
     */
    INFO = 3,
    /**
     * Normal but significant events, such as start up, shut down, or
     * configuration.
     *
     * @generated from protobuf enum value: NOTICE = 4;
     */
    NOTICE = 4,
    /**
     * Warning events might cause problems.
     *
     * @generated from protobuf enum value: WARN = 5;
     */
    WARN = 5,
    /**
     * Error events are likely to cause problems.
     *
     * @generated from protobuf enum value: ERROR = 6;
     */
    ERROR = 6,
    /**
     * Critical events cause severe problems or brief outages and may
     * indicate that a person must take action.
     *
     * @generated from protobuf enum value: CRITICAL = 7;
     */
    CRITICAL = 7
}
/**
 * @generated from protobuf message org.apache.beam.model.fn_execution.v1.LogControl
 */
export interface LogControl {
}
/**
 * @generated from protobuf message org.apache.beam.model.fn_execution.v1.StartWorkerRequest
 */
export interface StartWorkerRequest {
    /**
     * @generated from protobuf field: string worker_id = 1;
     */
    workerId: string;
    /**
     * @generated from protobuf field: org.apache.beam.model.pipeline.v1.ApiServiceDescriptor control_endpoint = 2;
     */
    controlEndpoint?: ApiServiceDescriptor;
    /**
     * @generated from protobuf field: org.apache.beam.model.pipeline.v1.ApiServiceDescriptor logging_endpoint = 3;
     */
    loggingEndpoint?: ApiServiceDescriptor;
    /**
     * @generated from protobuf field: org.apache.beam.model.pipeline.v1.ApiServiceDescriptor artifact_endpoint = 4;
     */
    artifactEndpoint?: ApiServiceDescriptor;
    /**
     * @generated from protobuf field: org.apache.beam.model.pipeline.v1.ApiServiceDescriptor provision_endpoint = 5;
     */
    provisionEndpoint?: ApiServiceDescriptor;
    /**
     * @generated from protobuf field: map<string, string> params = 10;
     */
    params: {
        [key: string]: string;
    };
}
/**
 * @generated from protobuf message org.apache.beam.model.fn_execution.v1.StartWorkerResponse
 */
export interface StartWorkerResponse {
    /**
     * @generated from protobuf field: string error = 1;
     */
    error: string;
}
/**
 * @generated from protobuf message org.apache.beam.model.fn_execution.v1.StopWorkerRequest
 */
export interface StopWorkerRequest {
    /**
     * @generated from protobuf field: string worker_id = 1;
     */
    workerId: string;
}
/**
 * @generated from protobuf message org.apache.beam.model.fn_execution.v1.StopWorkerResponse
 */
export interface StopWorkerResponse {
    /**
     * @generated from protobuf field: string error = 1;
     */
    error: string;
}
/**
 * Request from runner to SDK Harness asking for its status. For more details see
 * https://s.apache.org/beam-fn-api-harness-status
 *
 * @generated from protobuf message org.apache.beam.model.fn_execution.v1.WorkerStatusRequest
 */
export interface WorkerStatusRequest {
    /**
     * (Required) Unique ID identifying this request.
     *
     * @generated from protobuf field: string id = 1;
     */
    id: string;
}
/**
 * Response from SDK Harness to runner containing the debug related status info.
 *
 * @generated from protobuf message org.apache.beam.model.fn_execution.v1.WorkerStatusResponse
 */
export interface WorkerStatusResponse {
    /**
     * (Required) Unique ID from the original request.
     *
     * @generated from protobuf field: string id = 1;
     */
    id: string;
    /**
     * (Optional) Error message if exception encountered generating the status response.
     *
     * @generated from protobuf field: string error = 2;
     */
    error: string;
    /**
     * (Optional) Status debugging info reported by SDK harness worker. Content and
     * format is not strongly enforced but should be print-friendly and
     * appropriate as an HTTP response body for end user. For details of the preferred
     * info to include in the message see
     * https://s.apache.org/beam-fn-api-harness-status
     *
     * @generated from protobuf field: string status_info = 3;
     */
    statusInfo: string;
}
declare class RemoteGrpcPort$Type extends MessageType<RemoteGrpcPort> {
    constructor();
    create(value?: PartialMessage<RemoteGrpcPort>): RemoteGrpcPort;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: RemoteGrpcPort): RemoteGrpcPort;
    internalBinaryWrite(message: RemoteGrpcPort, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.fn_execution.v1.RemoteGrpcPort
 */
export declare const RemoteGrpcPort: RemoteGrpcPort$Type;
declare class GetProcessBundleDescriptorRequest$Type extends MessageType<GetProcessBundleDescriptorRequest> {
    constructor();
    create(value?: PartialMessage<GetProcessBundleDescriptorRequest>): GetProcessBundleDescriptorRequest;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: GetProcessBundleDescriptorRequest): GetProcessBundleDescriptorRequest;
    internalBinaryWrite(message: GetProcessBundleDescriptorRequest, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.fn_execution.v1.GetProcessBundleDescriptorRequest
 */
export declare const GetProcessBundleDescriptorRequest: GetProcessBundleDescriptorRequest$Type;
declare class InstructionRequest$Type extends MessageType<InstructionRequest> {
    constructor();
    create(value?: PartialMessage<InstructionRequest>): InstructionRequest;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: InstructionRequest): InstructionRequest;
    internalBinaryWrite(message: InstructionRequest, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.fn_execution.v1.InstructionRequest
 */
export declare const InstructionRequest: InstructionRequest$Type;
declare class InstructionResponse$Type extends MessageType<InstructionResponse> {
    constructor();
    create(value?: PartialMessage<InstructionResponse>): InstructionResponse;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: InstructionResponse): InstructionResponse;
    internalBinaryWrite(message: InstructionResponse, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.fn_execution.v1.InstructionResponse
 */
export declare const InstructionResponse: InstructionResponse$Type;
declare class HarnessMonitoringInfosRequest$Type extends MessageType<HarnessMonitoringInfosRequest> {
    constructor();
    create(value?: PartialMessage<HarnessMonitoringInfosRequest>): HarnessMonitoringInfosRequest;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: HarnessMonitoringInfosRequest): HarnessMonitoringInfosRequest;
    internalBinaryWrite(message: HarnessMonitoringInfosRequest, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.fn_execution.v1.HarnessMonitoringInfosRequest
 */
export declare const HarnessMonitoringInfosRequest: HarnessMonitoringInfosRequest$Type;
declare class HarnessMonitoringInfosResponse$Type extends MessageType<HarnessMonitoringInfosResponse> {
    constructor();
    create(value?: PartialMessage<HarnessMonitoringInfosResponse>): HarnessMonitoringInfosResponse;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: HarnessMonitoringInfosResponse): HarnessMonitoringInfosResponse;
    private binaryReadMap1;
    internalBinaryWrite(message: HarnessMonitoringInfosResponse, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.fn_execution.v1.HarnessMonitoringInfosResponse
 */
export declare const HarnessMonitoringInfosResponse: HarnessMonitoringInfosResponse$Type;
declare class RegisterRequest$Type extends MessageType<RegisterRequest> {
    constructor();
    create(value?: PartialMessage<RegisterRequest>): RegisterRequest;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: RegisterRequest): RegisterRequest;
    internalBinaryWrite(message: RegisterRequest, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.fn_execution.v1.RegisterRequest
 */
export declare const RegisterRequest: RegisterRequest$Type;
declare class RegisterResponse$Type extends MessageType<RegisterResponse> {
    constructor();
    create(value?: PartialMessage<RegisterResponse>): RegisterResponse;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: RegisterResponse): RegisterResponse;
    internalBinaryWrite(message: RegisterResponse, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.fn_execution.v1.RegisterResponse
 */
export declare const RegisterResponse: RegisterResponse$Type;
declare class ProcessBundleDescriptor$Type extends MessageType<ProcessBundleDescriptor> {
    constructor();
    create(value?: PartialMessage<ProcessBundleDescriptor>): ProcessBundleDescriptor;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: ProcessBundleDescriptor): ProcessBundleDescriptor;
    private binaryReadMap2;
    private binaryReadMap3;
    private binaryReadMap4;
    private binaryReadMap5;
    private binaryReadMap6;
    internalBinaryWrite(message: ProcessBundleDescriptor, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.fn_execution.v1.ProcessBundleDescriptor
 */
export declare const ProcessBundleDescriptor: ProcessBundleDescriptor$Type;
declare class BundleApplication$Type extends MessageType<BundleApplication> {
    constructor();
    create(value?: PartialMessage<BundleApplication>): BundleApplication;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: BundleApplication): BundleApplication;
    private binaryReadMap4;
    internalBinaryWrite(message: BundleApplication, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.fn_execution.v1.BundleApplication
 */
export declare const BundleApplication: BundleApplication$Type;
declare class DelayedBundleApplication$Type extends MessageType<DelayedBundleApplication> {
    constructor();
    create(value?: PartialMessage<DelayedBundleApplication>): DelayedBundleApplication;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: DelayedBundleApplication): DelayedBundleApplication;
    internalBinaryWrite(message: DelayedBundleApplication, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.fn_execution.v1.DelayedBundleApplication
 */
export declare const DelayedBundleApplication: DelayedBundleApplication$Type;
declare class ProcessBundleRequest$Type extends MessageType<ProcessBundleRequest> {
    constructor();
    create(value?: PartialMessage<ProcessBundleRequest>): ProcessBundleRequest;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: ProcessBundleRequest): ProcessBundleRequest;
    internalBinaryWrite(message: ProcessBundleRequest, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.fn_execution.v1.ProcessBundleRequest
 */
export declare const ProcessBundleRequest: ProcessBundleRequest$Type;
declare class ProcessBundleRequest_CacheToken$Type extends MessageType<ProcessBundleRequest_CacheToken> {
    constructor();
    create(value?: PartialMessage<ProcessBundleRequest_CacheToken>): ProcessBundleRequest_CacheToken;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: ProcessBundleRequest_CacheToken): ProcessBundleRequest_CacheToken;
    internalBinaryWrite(message: ProcessBundleRequest_CacheToken, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.fn_execution.v1.ProcessBundleRequest.CacheToken
 */
export declare const ProcessBundleRequest_CacheToken: ProcessBundleRequest_CacheToken$Type;
declare class ProcessBundleRequest_CacheToken_UserState$Type extends MessageType<ProcessBundleRequest_CacheToken_UserState> {
    constructor();
    create(value?: PartialMessage<ProcessBundleRequest_CacheToken_UserState>): ProcessBundleRequest_CacheToken_UserState;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: ProcessBundleRequest_CacheToken_UserState): ProcessBundleRequest_CacheToken_UserState;
    internalBinaryWrite(message: ProcessBundleRequest_CacheToken_UserState, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.fn_execution.v1.ProcessBundleRequest.CacheToken.UserState
 */
export declare const ProcessBundleRequest_CacheToken_UserState: ProcessBundleRequest_CacheToken_UserState$Type;
declare class ProcessBundleRequest_CacheToken_SideInput$Type extends MessageType<ProcessBundleRequest_CacheToken_SideInput> {
    constructor();
    create(value?: PartialMessage<ProcessBundleRequest_CacheToken_SideInput>): ProcessBundleRequest_CacheToken_SideInput;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: ProcessBundleRequest_CacheToken_SideInput): ProcessBundleRequest_CacheToken_SideInput;
    internalBinaryWrite(message: ProcessBundleRequest_CacheToken_SideInput, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.fn_execution.v1.ProcessBundleRequest.CacheToken.SideInput
 */
export declare const ProcessBundleRequest_CacheToken_SideInput: ProcessBundleRequest_CacheToken_SideInput$Type;
declare class ProcessBundleResponse$Type extends MessageType<ProcessBundleResponse> {
    constructor();
    create(value?: PartialMessage<ProcessBundleResponse>): ProcessBundleResponse;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: ProcessBundleResponse): ProcessBundleResponse;
    private binaryReadMap5;
    internalBinaryWrite(message: ProcessBundleResponse, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.fn_execution.v1.ProcessBundleResponse
 */
export declare const ProcessBundleResponse: ProcessBundleResponse$Type;
declare class ProcessBundleProgressRequest$Type extends MessageType<ProcessBundleProgressRequest> {
    constructor();
    create(value?: PartialMessage<ProcessBundleProgressRequest>): ProcessBundleProgressRequest;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: ProcessBundleProgressRequest): ProcessBundleProgressRequest;
    internalBinaryWrite(message: ProcessBundleProgressRequest, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.fn_execution.v1.ProcessBundleProgressRequest
 */
export declare const ProcessBundleProgressRequest: ProcessBundleProgressRequest$Type;
declare class MonitoringInfosMetadataRequest$Type extends MessageType<MonitoringInfosMetadataRequest> {
    constructor();
    create(value?: PartialMessage<MonitoringInfosMetadataRequest>): MonitoringInfosMetadataRequest;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: MonitoringInfosMetadataRequest): MonitoringInfosMetadataRequest;
    internalBinaryWrite(message: MonitoringInfosMetadataRequest, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.fn_execution.v1.MonitoringInfosMetadataRequest
 */
export declare const MonitoringInfosMetadataRequest: MonitoringInfosMetadataRequest$Type;
declare class ProcessBundleProgressResponse$Type extends MessageType<ProcessBundleProgressResponse> {
    constructor();
    create(value?: PartialMessage<ProcessBundleProgressResponse>): ProcessBundleProgressResponse;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: ProcessBundleProgressResponse): ProcessBundleProgressResponse;
    private binaryReadMap5;
    internalBinaryWrite(message: ProcessBundleProgressResponse, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.fn_execution.v1.ProcessBundleProgressResponse
 */
export declare const ProcessBundleProgressResponse: ProcessBundleProgressResponse$Type;
declare class MonitoringInfosMetadataResponse$Type extends MessageType<MonitoringInfosMetadataResponse> {
    constructor();
    create(value?: PartialMessage<MonitoringInfosMetadataResponse>): MonitoringInfosMetadataResponse;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: MonitoringInfosMetadataResponse): MonitoringInfosMetadataResponse;
    private binaryReadMap1;
    internalBinaryWrite(message: MonitoringInfosMetadataResponse, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.fn_execution.v1.MonitoringInfosMetadataResponse
 */
export declare const MonitoringInfosMetadataResponse: MonitoringInfosMetadataResponse$Type;
declare class ProcessBundleSplitRequest$Type extends MessageType<ProcessBundleSplitRequest> {
    constructor();
    create(value?: PartialMessage<ProcessBundleSplitRequest>): ProcessBundleSplitRequest;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: ProcessBundleSplitRequest): ProcessBundleSplitRequest;
    private binaryReadMap3;
    internalBinaryWrite(message: ProcessBundleSplitRequest, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.fn_execution.v1.ProcessBundleSplitRequest
 */
export declare const ProcessBundleSplitRequest: ProcessBundleSplitRequest$Type;
declare class ProcessBundleSplitRequest_DesiredSplit$Type extends MessageType<ProcessBundleSplitRequest_DesiredSplit> {
    constructor();
    create(value?: PartialMessage<ProcessBundleSplitRequest_DesiredSplit>): ProcessBundleSplitRequest_DesiredSplit;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: ProcessBundleSplitRequest_DesiredSplit): ProcessBundleSplitRequest_DesiredSplit;
    internalBinaryWrite(message: ProcessBundleSplitRequest_DesiredSplit, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.fn_execution.v1.ProcessBundleSplitRequest.DesiredSplit
 */
export declare const ProcessBundleSplitRequest_DesiredSplit: ProcessBundleSplitRequest_DesiredSplit$Type;
declare class ProcessBundleSplitResponse$Type extends MessageType<ProcessBundleSplitResponse> {
    constructor();
    create(value?: PartialMessage<ProcessBundleSplitResponse>): ProcessBundleSplitResponse;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: ProcessBundleSplitResponse): ProcessBundleSplitResponse;
    internalBinaryWrite(message: ProcessBundleSplitResponse, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.fn_execution.v1.ProcessBundleSplitResponse
 */
export declare const ProcessBundleSplitResponse: ProcessBundleSplitResponse$Type;
declare class ProcessBundleSplitResponse_ChannelSplit$Type extends MessageType<ProcessBundleSplitResponse_ChannelSplit> {
    constructor();
    create(value?: PartialMessage<ProcessBundleSplitResponse_ChannelSplit>): ProcessBundleSplitResponse_ChannelSplit;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: ProcessBundleSplitResponse_ChannelSplit): ProcessBundleSplitResponse_ChannelSplit;
    internalBinaryWrite(message: ProcessBundleSplitResponse_ChannelSplit, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.fn_execution.v1.ProcessBundleSplitResponse.ChannelSplit
 */
export declare const ProcessBundleSplitResponse_ChannelSplit: ProcessBundleSplitResponse_ChannelSplit$Type;
declare class FinalizeBundleRequest$Type extends MessageType<FinalizeBundleRequest> {
    constructor();
    create(value?: PartialMessage<FinalizeBundleRequest>): FinalizeBundleRequest;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: FinalizeBundleRequest): FinalizeBundleRequest;
    internalBinaryWrite(message: FinalizeBundleRequest, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.fn_execution.v1.FinalizeBundleRequest
 */
export declare const FinalizeBundleRequest: FinalizeBundleRequest$Type;
declare class FinalizeBundleResponse$Type extends MessageType<FinalizeBundleResponse> {
    constructor();
    create(value?: PartialMessage<FinalizeBundleResponse>): FinalizeBundleResponse;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: FinalizeBundleResponse): FinalizeBundleResponse;
    internalBinaryWrite(message: FinalizeBundleResponse, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.fn_execution.v1.FinalizeBundleResponse
 */
export declare const FinalizeBundleResponse: FinalizeBundleResponse$Type;
declare class Elements$Type extends MessageType<Elements> {
    constructor();
    create(value?: PartialMessage<Elements>): Elements;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: Elements): Elements;
    internalBinaryWrite(message: Elements, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.fn_execution.v1.Elements
 */
export declare const Elements: Elements$Type;
declare class Elements_Data$Type extends MessageType<Elements_Data> {
    constructor();
    create(value?: PartialMessage<Elements_Data>): Elements_Data;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: Elements_Data): Elements_Data;
    internalBinaryWrite(message: Elements_Data, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.fn_execution.v1.Elements.Data
 */
export declare const Elements_Data: Elements_Data$Type;
declare class Elements_Timers$Type extends MessageType<Elements_Timers> {
    constructor();
    create(value?: PartialMessage<Elements_Timers>): Elements_Timers;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: Elements_Timers): Elements_Timers;
    internalBinaryWrite(message: Elements_Timers, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.fn_execution.v1.Elements.Timers
 */
export declare const Elements_Timers: Elements_Timers$Type;
declare class StateRequest$Type extends MessageType<StateRequest> {
    constructor();
    create(value?: PartialMessage<StateRequest>): StateRequest;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: StateRequest): StateRequest;
    internalBinaryWrite(message: StateRequest, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.fn_execution.v1.StateRequest
 */
export declare const StateRequest: StateRequest$Type;
declare class StateResponse$Type extends MessageType<StateResponse> {
    constructor();
    create(value?: PartialMessage<StateResponse>): StateResponse;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: StateResponse): StateResponse;
    internalBinaryWrite(message: StateResponse, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.fn_execution.v1.StateResponse
 */
export declare const StateResponse: StateResponse$Type;
declare class StateKey$Type extends MessageType<StateKey> {
    constructor();
    create(value?: PartialMessage<StateKey>): StateKey;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: StateKey): StateKey;
    internalBinaryWrite(message: StateKey, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.fn_execution.v1.StateKey
 */
export declare const StateKey: StateKey$Type;
declare class StateKey_Runner$Type extends MessageType<StateKey_Runner> {
    constructor();
    create(value?: PartialMessage<StateKey_Runner>): StateKey_Runner;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: StateKey_Runner): StateKey_Runner;
    internalBinaryWrite(message: StateKey_Runner, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.fn_execution.v1.StateKey.Runner
 */
export declare const StateKey_Runner: StateKey_Runner$Type;
declare class StateKey_IterableSideInput$Type extends MessageType<StateKey_IterableSideInput> {
    constructor();
    create(value?: PartialMessage<StateKey_IterableSideInput>): StateKey_IterableSideInput;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: StateKey_IterableSideInput): StateKey_IterableSideInput;
    internalBinaryWrite(message: StateKey_IterableSideInput, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.fn_execution.v1.StateKey.IterableSideInput
 */
export declare const StateKey_IterableSideInput: StateKey_IterableSideInput$Type;
declare class StateKey_MultimapSideInput$Type extends MessageType<StateKey_MultimapSideInput> {
    constructor();
    create(value?: PartialMessage<StateKey_MultimapSideInput>): StateKey_MultimapSideInput;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: StateKey_MultimapSideInput): StateKey_MultimapSideInput;
    internalBinaryWrite(message: StateKey_MultimapSideInput, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.fn_execution.v1.StateKey.MultimapSideInput
 */
export declare const StateKey_MultimapSideInput: StateKey_MultimapSideInput$Type;
declare class StateKey_MultimapKeysSideInput$Type extends MessageType<StateKey_MultimapKeysSideInput> {
    constructor();
    create(value?: PartialMessage<StateKey_MultimapKeysSideInput>): StateKey_MultimapKeysSideInput;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: StateKey_MultimapKeysSideInput): StateKey_MultimapKeysSideInput;
    internalBinaryWrite(message: StateKey_MultimapKeysSideInput, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.fn_execution.v1.StateKey.MultimapKeysSideInput
 */
export declare const StateKey_MultimapKeysSideInput: StateKey_MultimapKeysSideInput$Type;
declare class StateKey_BagUserState$Type extends MessageType<StateKey_BagUserState> {
    constructor();
    create(value?: PartialMessage<StateKey_BagUserState>): StateKey_BagUserState;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: StateKey_BagUserState): StateKey_BagUserState;
    internalBinaryWrite(message: StateKey_BagUserState, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.fn_execution.v1.StateKey.BagUserState
 */
export declare const StateKey_BagUserState: StateKey_BagUserState$Type;
declare class StateKey_MultimapKeysUserState$Type extends MessageType<StateKey_MultimapKeysUserState> {
    constructor();
    create(value?: PartialMessage<StateKey_MultimapKeysUserState>): StateKey_MultimapKeysUserState;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: StateKey_MultimapKeysUserState): StateKey_MultimapKeysUserState;
    internalBinaryWrite(message: StateKey_MultimapKeysUserState, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.fn_execution.v1.StateKey.MultimapKeysUserState
 */
export declare const StateKey_MultimapKeysUserState: StateKey_MultimapKeysUserState$Type;
declare class StateKey_MultimapUserState$Type extends MessageType<StateKey_MultimapUserState> {
    constructor();
    create(value?: PartialMessage<StateKey_MultimapUserState>): StateKey_MultimapUserState;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: StateKey_MultimapUserState): StateKey_MultimapUserState;
    internalBinaryWrite(message: StateKey_MultimapUserState, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.fn_execution.v1.StateKey.MultimapUserState
 */
export declare const StateKey_MultimapUserState: StateKey_MultimapUserState$Type;
declare class StateGetRequest$Type extends MessageType<StateGetRequest> {
    constructor();
    create(value?: PartialMessage<StateGetRequest>): StateGetRequest;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: StateGetRequest): StateGetRequest;
    internalBinaryWrite(message: StateGetRequest, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.fn_execution.v1.StateGetRequest
 */
export declare const StateGetRequest: StateGetRequest$Type;
declare class StateGetResponse$Type extends MessageType<StateGetResponse> {
    constructor();
    create(value?: PartialMessage<StateGetResponse>): StateGetResponse;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: StateGetResponse): StateGetResponse;
    internalBinaryWrite(message: StateGetResponse, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.fn_execution.v1.StateGetResponse
 */
export declare const StateGetResponse: StateGetResponse$Type;
declare class StateAppendRequest$Type extends MessageType<StateAppendRequest> {
    constructor();
    create(value?: PartialMessage<StateAppendRequest>): StateAppendRequest;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: StateAppendRequest): StateAppendRequest;
    internalBinaryWrite(message: StateAppendRequest, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.fn_execution.v1.StateAppendRequest
 */
export declare const StateAppendRequest: StateAppendRequest$Type;
declare class StateAppendResponse$Type extends MessageType<StateAppendResponse> {
    constructor();
    create(value?: PartialMessage<StateAppendResponse>): StateAppendResponse;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: StateAppendResponse): StateAppendResponse;
    internalBinaryWrite(message: StateAppendResponse, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.fn_execution.v1.StateAppendResponse
 */
export declare const StateAppendResponse: StateAppendResponse$Type;
declare class StateClearRequest$Type extends MessageType<StateClearRequest> {
    constructor();
    create(value?: PartialMessage<StateClearRequest>): StateClearRequest;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: StateClearRequest): StateClearRequest;
    internalBinaryWrite(message: StateClearRequest, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.fn_execution.v1.StateClearRequest
 */
export declare const StateClearRequest: StateClearRequest$Type;
declare class StateClearResponse$Type extends MessageType<StateClearResponse> {
    constructor();
    create(value?: PartialMessage<StateClearResponse>): StateClearResponse;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: StateClearResponse): StateClearResponse;
    internalBinaryWrite(message: StateClearResponse, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.fn_execution.v1.StateClearResponse
 */
export declare const StateClearResponse: StateClearResponse$Type;
declare class LogEntry$Type extends MessageType<LogEntry> {
    constructor();
    create(value?: PartialMessage<LogEntry>): LogEntry;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: LogEntry): LogEntry;
    internalBinaryWrite(message: LogEntry, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.fn_execution.v1.LogEntry
 */
export declare const LogEntry: LogEntry$Type;
declare class LogEntry_List$Type extends MessageType<LogEntry_List> {
    constructor();
    create(value?: PartialMessage<LogEntry_List>): LogEntry_List;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: LogEntry_List): LogEntry_List;
    internalBinaryWrite(message: LogEntry_List, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.fn_execution.v1.LogEntry.List
 */
export declare const LogEntry_List: LogEntry_List$Type;
declare class LogEntry_Severity$Type extends MessageType<LogEntry_Severity> {
    constructor();
    create(value?: PartialMessage<LogEntry_Severity>): LogEntry_Severity;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: LogEntry_Severity): LogEntry_Severity;
    internalBinaryWrite(message: LogEntry_Severity, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.fn_execution.v1.LogEntry.Severity
 */
export declare const LogEntry_Severity: LogEntry_Severity$Type;
declare class LogControl$Type extends MessageType<LogControl> {
    constructor();
    create(value?: PartialMessage<LogControl>): LogControl;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: LogControl): LogControl;
    internalBinaryWrite(message: LogControl, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.fn_execution.v1.LogControl
 */
export declare const LogControl: LogControl$Type;
declare class StartWorkerRequest$Type extends MessageType<StartWorkerRequest> {
    constructor();
    create(value?: PartialMessage<StartWorkerRequest>): StartWorkerRequest;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: StartWorkerRequest): StartWorkerRequest;
    private binaryReadMap10;
    internalBinaryWrite(message: StartWorkerRequest, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.fn_execution.v1.StartWorkerRequest
 */
export declare const StartWorkerRequest: StartWorkerRequest$Type;
declare class StartWorkerResponse$Type extends MessageType<StartWorkerResponse> {
    constructor();
    create(value?: PartialMessage<StartWorkerResponse>): StartWorkerResponse;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: StartWorkerResponse): StartWorkerResponse;
    internalBinaryWrite(message: StartWorkerResponse, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.fn_execution.v1.StartWorkerResponse
 */
export declare const StartWorkerResponse: StartWorkerResponse$Type;
declare class StopWorkerRequest$Type extends MessageType<StopWorkerRequest> {
    constructor();
    create(value?: PartialMessage<StopWorkerRequest>): StopWorkerRequest;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: StopWorkerRequest): StopWorkerRequest;
    internalBinaryWrite(message: StopWorkerRequest, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.fn_execution.v1.StopWorkerRequest
 */
export declare const StopWorkerRequest: StopWorkerRequest$Type;
declare class StopWorkerResponse$Type extends MessageType<StopWorkerResponse> {
    constructor();
    create(value?: PartialMessage<StopWorkerResponse>): StopWorkerResponse;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: StopWorkerResponse): StopWorkerResponse;
    internalBinaryWrite(message: StopWorkerResponse, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.fn_execution.v1.StopWorkerResponse
 */
export declare const StopWorkerResponse: StopWorkerResponse$Type;
declare class WorkerStatusRequest$Type extends MessageType<WorkerStatusRequest> {
    constructor();
    create(value?: PartialMessage<WorkerStatusRequest>): WorkerStatusRequest;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: WorkerStatusRequest): WorkerStatusRequest;
    internalBinaryWrite(message: WorkerStatusRequest, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.fn_execution.v1.WorkerStatusRequest
 */
export declare const WorkerStatusRequest: WorkerStatusRequest$Type;
declare class WorkerStatusResponse$Type extends MessageType<WorkerStatusResponse> {
    constructor();
    create(value?: PartialMessage<WorkerStatusResponse>): WorkerStatusResponse;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: WorkerStatusResponse): WorkerStatusResponse;
    internalBinaryWrite(message: WorkerStatusResponse, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.fn_execution.v1.WorkerStatusResponse
 */
export declare const WorkerStatusResponse: WorkerStatusResponse$Type;
/**
 * @generated ServiceType for protobuf service org.apache.beam.model.fn_execution.v1.BeamFnControl
 */
export declare const BeamFnControl: ServiceType;
/**
 * @generated ServiceType for protobuf service org.apache.beam.model.fn_execution.v1.BeamFnData
 */
export declare const BeamFnData: ServiceType;
/**
 * @generated ServiceType for protobuf service org.apache.beam.model.fn_execution.v1.BeamFnState
 */
export declare const BeamFnState: ServiceType;
/**
 * @generated ServiceType for protobuf service org.apache.beam.model.fn_execution.v1.BeamFnLogging
 */
export declare const BeamFnLogging: ServiceType;
/**
 * @generated ServiceType for protobuf service org.apache.beam.model.fn_execution.v1.BeamFnExternalWorkerPool
 */
export declare const BeamFnExternalWorkerPool: ServiceType;
/**
 * @generated ServiceType for protobuf service org.apache.beam.model.fn_execution.v1.BeamFnWorkerStatus
 */
export declare const BeamFnWorkerStatus: ServiceType;
export {};
