import type { BinaryWriteOptions } from "@protobuf-ts/runtime";
import type { BinaryReadOptions } from "@protobuf-ts/runtime";
import type { GetProvisionInfoResponse } from "./beam_provision_api";
import type { GetProvisionInfoRequest } from "./beam_provision_api";
import * as grpc from "@grpc/grpc-js";
/**
 * A service to provide runtime provisioning information to the SDK harness
 * worker instances -- such as pipeline options, resource constraints and
 * other job metadata -- needed by an SDK harness instance to initialize.
 *
 * @generated from protobuf service org.apache.beam.model.fn_execution.v1.ProvisionService
 */
export interface IProvisionServiceClient {
    /**
     * Get provision information for the SDK harness worker instance.
     *
     * @generated from protobuf rpc: GetProvisionInfo(org.apache.beam.model.fn_execution.v1.GetProvisionInfoRequest) returns (org.apache.beam.model.fn_execution.v1.GetProvisionInfoResponse);
     */
    getProvisionInfo(input: GetProvisionInfoRequest, metadata: grpc.Metadata, options: grpc.CallOptions, callback: (err: grpc.ServiceError | null, value?: GetProvisionInfoResponse) => void): grpc.ClientUnaryCall;
    getProvisionInfo(input: GetProvisionInfoRequest, metadata: grpc.Metadata, callback: (err: grpc.ServiceError | null, value?: GetProvisionInfoResponse) => void): grpc.ClientUnaryCall;
    getProvisionInfo(input: GetProvisionInfoRequest, options: grpc.CallOptions, callback: (err: grpc.ServiceError | null, value?: GetProvisionInfoResponse) => void): grpc.ClientUnaryCall;
    getProvisionInfo(input: GetProvisionInfoRequest, callback: (err: grpc.ServiceError | null, value?: GetProvisionInfoResponse) => void): grpc.ClientUnaryCall;
}
/**
 * A service to provide runtime provisioning information to the SDK harness
 * worker instances -- such as pipeline options, resource constraints and
 * other job metadata -- needed by an SDK harness instance to initialize.
 *
 * @generated from protobuf service org.apache.beam.model.fn_execution.v1.ProvisionService
 */
export declare class ProvisionServiceClient extends grpc.Client implements IProvisionServiceClient {
    private readonly _binaryOptions;
    constructor(address: string, credentials: grpc.ChannelCredentials, options?: grpc.ClientOptions, binaryOptions?: Partial<BinaryReadOptions & BinaryWriteOptions>);
    /**
     * Get provision information for the SDK harness worker instance.
     *
     * @generated from protobuf rpc: GetProvisionInfo(org.apache.beam.model.fn_execution.v1.GetProvisionInfoRequest) returns (org.apache.beam.model.fn_execution.v1.GetProvisionInfoResponse);
     */
    getProvisionInfo(input: GetProvisionInfoRequest, metadata: grpc.Metadata | grpc.CallOptions | ((err: grpc.ServiceError | null, value?: GetProvisionInfoResponse) => void), options?: grpc.CallOptions | ((err: grpc.ServiceError | null, value?: GetProvisionInfoResponse) => void), callback?: ((err: grpc.ServiceError | null, value?: GetProvisionInfoResponse) => void)): grpc.ClientUnaryCall;
}
