import { PValue } from "../pvalue";
import * as transform from "./transform";
import { Coder } from "../coders/coders";
import * as service from "../utils/service";
/**
 * Various transforms useful for creating and invoking cross-language
 * transforms.
 *
 * See also https://beam.apache.org/documentation/programming-guide/#1324-using-cross-language-transforms-in-a-typescript-pipeline
 *
 * @packageDocumentation
 */
export interface RawExternalTransformOptions {
    inferPValueType?: boolean;
    requestedOutputCoders?: {
        [key: string]: Coder<unknown>;
    };
}
export declare function rawExternalTransform<InputT extends PValue<any>, OutputT extends PValue<any>>(urn: string, payload: Uint8Array | {
    [key: string]: any;
}, serviceProviderOrAddress: string | (() => Promise<service.Service>), options?: RawExternalTransformOptions): transform.AsyncPTransform<InputT, OutputT>;
