import * as transform from "./transform";
import { PCollection } from "../pvalue";
/**
 * Runs an SQL statement over a set of input PCollection(s).
 *
 * The input can either be a single PCollection, in which case the table is
 * named PCOLLECTION, or an object with PCollection values, in which case the
 * corresponding names can be used in the sql statement.
 *
 * The input(s) must be schema'd (i.e. use the RowCoder). This can be done
 * by explicitly setting the schema with external.withRowCoder or passing
 * a prototype element in as a second argument, e.g.
 *
 * pcoll.applyAsync(
 *    sqlTransform(
 *        "select a, b from PCOLLECTION",
 *        {a: 0, b: "string"},
 *    ));
 */
export declare function sqlTransform<InputT extends PCollection<any> | {
    [key: string]: PCollection<any>;
}>(query: string, inputTypes?: null): transform.AsyncPTransform<InputT, PCollection<any>>;
