"use strict";
/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/** @internal */
function camelToSnake(camelString) {
    return camelString.replace(/[A-Z]/g, (letter) => `_${letter.toLowerCase()}`);
}
/** @internal */
function camelToSnakeOptions(options) {
    return Object.fromEntries(Object.entries(options)
        .filter(([k, v]) => v != undefined)
        .map((_tct_transform_1 = ([k, v]) => [camelToSnake(k), v], _tct_transform_1.__closure = () => ({ camelToSnake }), _tct_transform_1)));
}
var _tct_transform_1;
camelToSnakeOptions.__closure = () => ({ Object, camelToSnake });
Object.defineProperty(exports, "__esModule", { value: true });
exports.camelToSnakeOptions = exports.camelToSnake = void 0;
exports.camelToSnake = camelToSnake;
exports.camelToSnakeOptions = camelToSnakeOptions;
//# sourceMappingURL=utils.js.map