"use strict";
/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ExternalWorkerPool = void 0;
const _tct_flatten_destructured_imports_1 = __importStar(require("@grpc/grpc-js"));
var grpc = _tct_flatten_destructured_imports_1;
const _tct_flatten_destructured_imports_2 = __importStar(require("../proto/beam_fn_api"));
var StartWorkerRequest = _tct_flatten_destructured_imports_2.StartWorkerRequest;
var StartWorkerResponse = _tct_flatten_destructured_imports_2.StartWorkerResponse;
var StopWorkerRequest = _tct_flatten_destructured_imports_2.StopWorkerRequest;
var StopWorkerResponse = _tct_flatten_destructured_imports_2.StopWorkerResponse;
const _tct_flatten_destructured_imports_3 = __importStar(require("../proto/beam_fn_api.grpc-server"));
var beamFnExternalWorkerPoolDefinition = _tct_flatten_destructured_imports_3.beamFnExternalWorkerPoolDefinition;
var IBeamFnExternalWorkerPool = _tct_flatten_destructured_imports_3.IBeamFnExternalWorkerPool;
const _tct_flatten_destructured_imports_4 = __importStar(require("./worker"));
var Worker = _tct_flatten_destructured_imports_4.Worker;
var WorkerEndpoints = _tct_flatten_destructured_imports_4.WorkerEndpoints;
class ExternalWorkerPool {
    constructor(address = "localhost:0") {
        this.workers = new Map();
        this.address = address;
    }
    async start() {
        var _tct_transform_1;
        console.info("Starting loopback workers at ", this.address);
        const this_ = this;
        this.server = new grpc.Server();
        const workerService = {
            startWorker(call, callback) {
                var _tct_transform_2;
                call.on("error", (_tct_transform_2 = (args) => {
                    console.error("unary() got error:", args);
                }, _tct_transform_2.__closure = () => ({ console }), _tct_transform_2));
                this_.workers.set(call.request.workerId, new Worker(call.request.workerId, {
                    controlUrl: call.request?.controlEndpoint?.url,
                }, {}));
                callback(null, {
                    error: "",
                });
            },
            stopWorker(call, callback) {
                this_.workers.get(call.request.workerId)?.stop();
                this_.workers.delete(call.request.workerId);
                callback(null, {
                    error: "",
                });
            },
        };
        this.server.addService(beamFnExternalWorkerPoolDefinition, workerService);
        return new Promise((_tct_transform_1 = (resolve, reject) => {
            var _tct_transform_3;
            this.server.bindAsync(this.address, grpc.ServerCredentials.createInsecure(), (_tct_transform_3 = (err, port) => {
                if (err) {
                    reject(`Error starting loopback service: ${err.message}`);
                }
                else {
                    console.info(`Server bound on port: ${port}`);
                    this_.address = `localhost:${port}`;
                    this_.server.start();
                    resolve(this_.address);
                }
            }, _tct_transform_3.__closure = () => ({ reject, console, this_, resolve }), _tct_transform_3));
        }, _tct_transform_1.__closure = () => ({ grpc, console, this_ }), _tct_transform_1));
    }
    async stop(timeoutMs = 100) {
        var _tct_transform_4;
        console.debug("Shutting down external workers.");
        // Let the runner attempt to gracefully shut these down.
        const start = Date.now();
        while (Date.now() - start < timeoutMs) {
            if (this.workers.size) {
                await new Promise((_tct_transform_4 = (r) => setTimeout(r, timeoutMs / 10), _tct_transform_4.__closure = () => ({ setTimeout, timeoutMs }), _tct_transform_4));
            }
        }
        this.server.forceShutdown();
    }
}
exports.ExternalWorkerPool = ExternalWorkerPool;
const default_host = "localhost:5555";
if (require.main === module) {
    new ExternalWorkerPool(default_host).start();
}
//# sourceMappingURL=external_worker_service.js.map