"use strict";
/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var _tct_transform_1;
Object.defineProperty(exports, "__esModule", { value: true });
const _tct_flatten_destructured_imports_1 = __importStar(require("../src/apache_beam"));
var beam = _tct_flatten_destructured_imports_1;
const _tct_flatten_destructured_imports_2 = __importStar(require("assert"));
var assert = _tct_flatten_destructured_imports_2;
const _tct_flatten_destructured_imports_3 = __importStar(require("../src/apache_beam/coders/coders"));
var Context = _tct_flatten_destructured_imports_3.Context;
const _tct_flatten_destructured_imports_4 = __importStar(require("../src/apache_beam/coders/standard_coders"));
var BytesCoder = _tct_flatten_destructured_imports_4.BytesCoder;
var IterableCoder = _tct_flatten_destructured_imports_4.IterableCoder;
var KVCoder = _tct_flatten_destructured_imports_4.KVCoder;
var StrUtf8Coder = _tct_flatten_destructured_imports_4.StrUtf8Coder;
var VarIntCoder = _tct_flatten_destructured_imports_4.VarIntCoder;
const _tct_flatten_destructured_imports_5 = __importStar(require("../src/apache_beam/coders/js_coders"));
var BsonObjectCoder = _tct_flatten_destructured_imports_5.BsonObjectCoder;
var GeneralObjectCoder = _tct_flatten_destructured_imports_5.GeneralObjectCoder;
const _tct_flatten_destructured_imports_6 = __importStar(require("protobufjs"));
var BufferReader = _tct_flatten_destructured_imports_6.BufferReader;
var BufferWriter = _tct_flatten_destructured_imports_6.BufferWriter;
describe("JavaScript native coders", (_tct_transform_1 = function () {
    var _tct_transform_2, _tct_transform_3;
    describe("BSON Object Coder", (_tct_transform_2 = function () {
        var _tct_transform_4;
        const bsonCoder = new BsonObjectCoder();
        it("encodes and decodes an object properly", (_tct_transform_4 = function () {
            const inputObject = {
                str: "astring",
                int: 1,
                float: 1.2345,
                obj: { any: "any" },
                null: null,
                bool: true,
                // 'undef': undefined,  // TODO(pabloem): Figure out how to support undefined encoding/decoding.
                bigint: Number.MAX_SAFE_INTEGER + 100,
            };
            const writer = new BufferWriter();
            const encoded = bsonCoder.encode(inputObject, writer, Context.needsDelimiters);
            const buffer = writer.finish();
            const reader = new BufferReader(buffer);
            assert.deepEqual(bsonCoder.decode(reader, Context.needsDelimiters), inputObject);
        }, _tct_transform_4.__closure = () => ({ Number, BufferWriter, bsonCoder, Context, BufferReader, assert }), _tct_transform_4));
    }, _tct_transform_2.__closure = () => ({ BsonObjectCoder, it, Number, BufferWriter, Context, BufferReader, assert }), _tct_transform_2));
    describe("general object coder", (_tct_transform_3 = function () {
        var _tct_transform_5, _tct_transform_6, _tct_transform_7, _tct_transform_8, _tct_transform_9, _tct_transform_10, _tct_transform_11;
        const objCoder = new GeneralObjectCoder();
        it("encodes and decodes an object properly", (_tct_transform_5 = function () {
            const inputObject = {
                str: "astring",
                int: 1,
                float: 1.2345,
                obj: { any: "any" },
                null: null,
                bool: true,
                array: [1, 2, 3],
                // 'undef': undefined,  // TODO(pabloem): Figure out how to support undefined encoding/decoding.
                bigint: Number.MAX_SAFE_INTEGER + 100,
            };
            const writer = new BufferWriter();
            const encoded = objCoder.encode(inputObject, writer, Context.needsDelimiters);
            const buffer = writer.finish();
            const reader = new BufferReader(buffer);
            assert.deepEqual(objCoder.decode(reader, Context.needsDelimiters), inputObject);
        }, _tct_transform_5.__closure = () => ({ Number, BufferWriter, objCoder, Context, BufferReader, assert }), _tct_transform_5));
        it("encodes and decodes a string properly", (_tct_transform_6 = function () {
            const inputObject = "abcde";
            const writer = new BufferWriter();
            const encoded = objCoder.encode(inputObject, writer, Context.needsDelimiters);
            const buffer = writer.finish();
            const reader = new BufferReader(buffer);
            assert.equal(objCoder.decode(reader, Context.needsDelimiters), inputObject);
        }, _tct_transform_6.__closure = () => ({ BufferWriter, objCoder, Context, BufferReader, assert }), _tct_transform_6));
        it("encodes and decodes an integer properly", (_tct_transform_7 = function () {
            const inputObject = 12345678;
            const writer = new BufferWriter();
            const encoded = objCoder.encode(inputObject, writer, Context.needsDelimiters);
            const buffer = writer.finish();
            const reader = new BufferReader(buffer);
            assert.deepEqual(objCoder.decode(reader, Context.needsDelimiters), inputObject);
        }, _tct_transform_7.__closure = () => ({ BufferWriter, objCoder, Context, BufferReader, assert }), _tct_transform_7));
        it("encodes and decodes a float properly", (_tct_transform_8 = function () {
            const inputObject = 0.12345678;
            const writer = new BufferWriter();
            const encoded = objCoder.encode(inputObject, writer, Context.needsDelimiters);
            const buffer = writer.finish();
            const reader = new BufferReader(buffer);
            assert.deepEqual(objCoder.decode(reader, Context.needsDelimiters), inputObject);
        }, _tct_transform_8.__closure = () => ({ BufferWriter, objCoder, Context, BufferReader, assert }), _tct_transform_8));
        it("encodes and decodes a BigInt properly", (_tct_transform_9 = function () {
            // TODO(pabloem): THIS TEST NEEDS TO BE sKIPPED BECAUSE VERY LARGE INTS ARE BROKEN
            this.skip();
            const inputObject = Number.MAX_SAFE_INTEGER + 123456789;
            const writer = new BufferWriter();
            const encoded = objCoder.encode(inputObject, writer, Context.needsDelimiters);
            const buffer = writer.finish();
            const reader = new BufferReader(buffer);
            assert.deepEqual(objCoder.decode(reader, Context.needsDelimiters), inputObject);
        }, _tct_transform_9.__closure = () => ({ Number, BufferWriter, objCoder, Context, BufferReader, assert }), _tct_transform_9));
        it("encodes and decodes a true boolean properly", (_tct_transform_10 = function () {
            const inputObject = true;
            const writer = new BufferWriter();
            const encoded = objCoder.encode(inputObject, writer, Context.needsDelimiters);
            const buffer = writer.finish();
            const reader = new BufferReader(buffer);
            assert.equal(objCoder.decode(reader, Context.needsDelimiters), inputObject);
        }, _tct_transform_10.__closure = () => ({ BufferWriter, objCoder, Context, BufferReader, assert }), _tct_transform_10));
        it("encodes and decodes a false boolean properly", (_tct_transform_11 = function () {
            const inputObject = false;
            const writer = new BufferWriter();
            const encoded = objCoder.encode(inputObject, writer, Context.needsDelimiters);
            const buffer = writer.finish();
            const reader = new BufferReader(buffer);
            assert.equal(objCoder.decode(reader, Context.needsDelimiters), inputObject);
        }, _tct_transform_11.__closure = () => ({ BufferWriter, objCoder, Context, BufferReader, assert }), _tct_transform_11));
    }, _tct_transform_3.__closure = () => ({ GeneralObjectCoder, it, Number, BufferWriter, Context, BufferReader, assert }), _tct_transform_3));
}, _tct_transform_1.__closure = () => ({ describe, BsonObjectCoder, it, Number, BufferWriter, Context, BufferReader, assert, GeneralObjectCoder }), _tct_transform_1));
//# sourceMappingURL=js_coders_test.js.map