"use strict";
/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
function removeUndefined(obj) {
    for (const prop in obj) {
        if (obj[prop] === undefined) {
            delete obj[prop];
        }
    }
    return obj;
}
var _tct_transform_1;
Object.defineProperty(exports, "__esModule", { value: true });
const _tct_flatten_destructured_imports_1 = __importStar(require("../src/apache_beam"));
var beam = _tct_flatten_destructured_imports_1;
const _tct_flatten_destructured_imports_2 = __importStar(require("assert"));
var assert = _tct_flatten_destructured_imports_2;
const _tct_flatten_destructured_imports_3 = __importStar(require("../src/apache_beam/coders/coders"));
var Context = _tct_flatten_destructured_imports_3.Context;
const _tct_flatten_destructured_imports_4 = __importStar(require("../src/apache_beam/coders/row_coder"));
var RowCoder = _tct_flatten_destructured_imports_4.RowCoder;
const _tct_flatten_destructured_imports_5 = __importStar(require("protobufjs"));
var BufferReader = _tct_flatten_destructured_imports_5.BufferReader;
var BufferWriter = _tct_flatten_destructured_imports_5.BufferWriter;
describe("encodes and decodes with RowCoder", (_tct_transform_1 = function () {
    var _tct_transform_2;
    const rowCoder = new RowCoder(RowCoder.inferSchemaOfJSON({
        str_field: "str",
        int_field: 4,
        //float_field: 2.7,
        repeated_field: [1, 2, 3],
        nested_field: { a: 1, b: 2 },
    }));
    const cases = {
        full: {
            str_field: "Aaaaaaaaaaaaaa",
            int_field: 4,
            //float_field: 2.7,
            repeated_field: [1, 2, 3],
            nested_field: { a: 1, b: 2 },
        },
        empty: {},
        half: { str_field: "Bbbbbbbbbb", nested_field: { a: 123, b: 321 } },
        str_only: { str_field: "Abc" },
        int_only: { int_field: 49 },
        repated_only: { repeated_field: [1, 4, 9, 16] },
        nested_only: { nested_field: { a: 100, b: -100 } },
    };
    for (let descr in cases) {
        it("encodes and decodes " + descr, (_tct_transform_2 = function () {
            const writer = new BufferWriter();
            const inputObject = cases[descr];
            const encoded = rowCoder.encode(inputObject, writer, Context.needsDelimiters);
            const buffer = writer.finish();
            const reader = new BufferReader(buffer);
            assert.deepEqual(removeUndefined(rowCoder.decode(reader, Context.needsDelimiters)), inputObject);
        }, _tct_transform_2.__closure = () => ({ BufferWriter, cases, descr, rowCoder, Context, BufferReader, assert, removeUndefined }), _tct_transform_2));
    }
}, _tct_transform_1.__closure = () => ({ RowCoder, it, BufferWriter, Context, BufferReader, assert, removeUndefined }), _tct_transform_1));
//# sourceMappingURL=row_coder_test.js.map