"use strict";
/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
function globalWindows() {
    return {
        assignWindows: (_tct_transform_1 = (Instant) => [new GlobalWindow()], _tct_transform_1.__closure = () => ({ GlobalWindow }), _tct_transform_1),
        windowCoder: (_tct_transform_2 = () => new GlobalWindowCoder(), _tct_transform_2.__closure = () => ({ GlobalWindowCoder }), _tct_transform_2),
        isMerging: () => false,
        assignsToOneWindow: () => true,
        toProto: (_tct_transform_3 = () => ({
            urn: "beam:window_fn:global_windows:v1",
            payload: new Uint8Array(),
        }), _tct_transform_3.__closure = () => ({ Uint8Array }), _tct_transform_3),
    };
}
var _tct_transform_1, _tct_transform_2, _tct_transform_3, _tct_transform_4, _tct_transform_5, _tct_transform_6, _tct_transform_7, _tct_transform_8, _tct_transform_9;
globalWindows.__closure = () => ({ GlobalWindow, GlobalWindowCoder, Uint8Array });
function fixedWindows(sizeSeconds, offsetSeconds = Long.fromValue(0)) {
    // TODO: (Cleanup) Use a time library?
    const sizeMillis = secsToMillisLong(sizeSeconds);
    const offsetMillis = secsToMillisLong(offsetSeconds);
    return {
        assignWindows: (_tct_transform_4 = (t) => {
            const start = t.sub(t.sub(offsetMillis).mod(sizeMillis));
            return [new IntervalWindow(start, start.add(sizeMillis))];
        }, _tct_transform_4.__closure = () => ({ offsetMillis, sizeMillis, IntervalWindow }), _tct_transform_4),
        windowCoder: (_tct_transform_5 = () => new IntervalWindowCoder(), _tct_transform_5.__closure = () => ({ IntervalWindowCoder }), _tct_transform_5),
        isMerging: () => false,
        assignsToOneWindow: () => true,
        toProto: (_tct_transform_6 = () => ({
            urn: "beam:window_fn:fixed_windows:v1",
            payload: FixedWindowsPayload.toBinary({
                size: millisToProto(sizeMillis),
                offset: millisToProto(offsetMillis),
            }),
        }), _tct_transform_6.__closure = () => ({ FixedWindowsPayload, millisToProto, sizeMillis, offsetMillis }), _tct_transform_6),
    };
}
fixedWindows.__closure = () => ({ secsToMillisLong, IntervalWindow, IntervalWindowCoder, FixedWindowsPayload, millisToProto });
function sessions(gapSeconds) {
    const gapMillis = secsToMillisLong(gapSeconds);
    return {
        assignWindows: (_tct_transform_7 = (t) => [new IntervalWindow(t, t.add(gapMillis))], _tct_transform_7.__closure = () => ({ IntervalWindow, gapMillis }), _tct_transform_7),
        windowCoder: (_tct_transform_8 = () => new IntervalWindowCoder(), _tct_transform_8.__closure = () => ({ IntervalWindowCoder }), _tct_transform_8),
        isMerging: () => true,
        assignsToOneWindow: () => true,
        toProto: (_tct_transform_9 = () => ({
            urn: "beam:window_fn:session_windows:v1",
            payload: SessionWindowsPayload.toBinary({
                gapSize: millisToProto(gapMillis),
            }),
        }), _tct_transform_9.__closure = () => ({ SessionWindowsPayload, millisToProto, gapMillis }), _tct_transform_9),
    };
}
sessions.__closure = () => ({ secsToMillisLong, IntervalWindow, IntervalWindowCoder, SessionWindowsPayload, millisToProto });
function secsToMillisLong(secs) {
    if (typeof secs === "number") {
        return Long.fromValue(secs * 1000);
    }
    else {
        return secs.mul(1000);
    }
}
secsToMillisLong.__closure = () => ({ Long });
function millisToProto(t) {
    return { seconds: BigInt(t.div(1000).toString()), nanos: 0 };
}
millisToProto.__closure = () => ({ BigInt });
Object.defineProperty(exports, "__esModule", { value: true });
exports.sessions = exports.fixedWindows = exports.globalWindows = void 0;
const long_1 = __importStar(require("long")), _tct_flatten_destructured_imports_1 = long_1;
var Long = _tct_flatten_destructured_imports_1.default;
const _tct_flatten_destructured_imports_2 = __importStar(require("../proto/beam_runner_api"));
var runnerApi = _tct_flatten_destructured_imports_2;
const _tct_flatten_destructured_imports_3 = __importStar(require("../proto/standard_window_fns"));
var FixedWindowsPayload = _tct_flatten_destructured_imports_3.FixedWindowsPayload;
var SessionWindowsPayload = _tct_flatten_destructured_imports_3.SessionWindowsPayload;
const _tct_flatten_destructured_imports_4 = __importStar(require("./window"));
var WindowFn = _tct_flatten_destructured_imports_4.WindowFn;
const _tct_flatten_destructured_imports_5 = __importStar(require("../coders/standard_coders"));
var GlobalWindowCoder = _tct_flatten_destructured_imports_5.GlobalWindowCoder;
var IntervalWindowCoder = _tct_flatten_destructured_imports_5.IntervalWindowCoder;
const _tct_flatten_destructured_imports_6 = __importStar(require("../values"));
var GlobalWindow = _tct_flatten_destructured_imports_6.GlobalWindow;
var Instant = _tct_flatten_destructured_imports_6.Instant;
var IntervalWindow = _tct_flatten_destructured_imports_6.IntervalWindow;
exports.globalWindows = globalWindows;
exports.fixedWindows = fixedWindows;
exports.sessions = sessions;
const _tct_flatten_destructured_imports_7 = __importStar(require("../serialization"));
var requireForSerialization = _tct_flatten_destructured_imports_7.requireForSerialization;
requireForSerialization("apache_beam.transforms.windowings", exports);
requireForSerialization("apache_beam.transforms.windowings", millisToProto);
requireForSerialization("apache_beam.transforms.windowings", FixedWindowsPayload);
requireForSerialization("apache_beam.transforms.windowings", SessionWindowsPayload);
//# sourceMappingURL=windowings.js.map